/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.xmlsoap.schemas.ws._2003._03.business.process.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import org.xmlsoap.schemas.ws._2003._03.business.process.util.ProcessAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ProcessItemProviderAdapterFactory extends ProcessAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable
{
  /**
   * This keeps track of the root adapter factory that delegates to this adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ComposedAdapterFactory parentAdapterFactory;

  /**
   * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IChangeNotifier changeNotifier = new ChangeNotifier();

  /**
   * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected Collection supportedTypes = new ArrayList();

  /**
   * This constructs an instance.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ProcessItemProviderAdapterFactory()
  {
    supportedTypes.add(IEditingDomainItemProvider.class);
    supportedTypes.add(IStructuredItemContentProvider.class);
    supportedTypes.add(ITreeItemContentProvider.class);
    supportedTypes.add(IItemLabelProvider.class);
    supportedTypes.add(IItemPropertySource.class);		
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.CaseType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CaseTypeItemProvider caseTypeItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.CaseType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCaseTypeAdapter()
  {
    if (caseTypeItemProvider == null)
    {
      caseTypeItemProvider = new CaseTypeItemProvider(this);
    }

    return caseTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.DocumentRoot} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DocumentRootItemProvider documentRootItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.DocumentRoot}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createDocumentRootAdapter()
  {
    if (documentRootItemProvider == null)
    {
      documentRootItemProvider = new DocumentRootItemProvider(this);
    }

    return documentRootItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.PartnerLinkType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PartnerLinkTypeItemProvider partnerLinkTypeItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.PartnerLinkType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createPartnerLinkTypeAdapter()
  {
    if (partnerLinkTypeItemProvider == null)
    {
      partnerLinkTypeItemProvider = new PartnerLinkTypeItemProvider(this);
    }

    return partnerLinkTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TActivity} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TActivityItemProvider tActivityItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TActivity}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTActivityAdapter()
  {
    if (tActivityItemProvider == null)
    {
      tActivityItemProvider = new TActivityItemProvider(this);
    }

    return tActivityItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TActivityContainer} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TActivityContainerItemProvider tActivityContainerItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TActivityContainer}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTActivityContainerAdapter()
  {
    if (tActivityContainerItemProvider == null)
    {
      tActivityContainerItemProvider = new TActivityContainerItemProvider(this);
    }

    return tActivityContainerItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TActivityOrCompensateContainer} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TActivityOrCompensateContainerItemProvider tActivityOrCompensateContainerItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TActivityOrCompensateContainer}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTActivityOrCompensateContainerAdapter()
  {
    if (tActivityOrCompensateContainerItemProvider == null)
    {
      tActivityOrCompensateContainerItemProvider = new TActivityOrCompensateContainerItemProvider(this);
    }

    return tActivityOrCompensateContainerItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TAssign} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TAssignItemProvider tAssignItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TAssign}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTAssignAdapter()
  {
    if (tAssignItemProvider == null)
    {
      tAssignItemProvider = new TAssignItemProvider(this);
    }

    return tAssignItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCatch} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TCatchItemProvider tCatchItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCatch}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTCatchAdapter()
  {
    if (tCatchItemProvider == null)
    {
      tCatchItemProvider = new TCatchItemProvider(this);
    }

    return tCatchItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCompensate} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TCompensateItemProvider tCompensateItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCompensate}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTCompensateAdapter()
  {
    if (tCompensateItemProvider == null)
    {
      tCompensateItemProvider = new TCompensateItemProvider(this);
    }

    return tCompensateItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCompensationHandler} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TCompensationHandlerItemProvider tCompensationHandlerItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCompensationHandler}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTCompensationHandlerAdapter()
  {
    if (tCompensationHandlerItemProvider == null)
    {
      tCompensationHandlerItemProvider = new TCompensationHandlerItemProvider(this);
    }

    return tCompensationHandlerItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCopy} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TCopyItemProvider tCopyItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCopy}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTCopyAdapter()
  {
    if (tCopyItemProvider == null)
    {
      tCopyItemProvider = new TCopyItemProvider(this);
    }

    return tCopyItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCorrelation} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TCorrelationItemProvider tCorrelationItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCorrelation}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTCorrelationAdapter()
  {
    if (tCorrelationItemProvider == null)
    {
      tCorrelationItemProvider = new TCorrelationItemProvider(this);
    }

    return tCorrelationItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCorrelations} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TCorrelationsItemProvider tCorrelationsItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCorrelations}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTCorrelationsAdapter()
  {
    if (tCorrelationsItemProvider == null)
    {
      tCorrelationsItemProvider = new TCorrelationsItemProvider(this);
    }

    return tCorrelationsItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCorrelationSet} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TCorrelationSetItemProvider tCorrelationSetItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCorrelationSet}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTCorrelationSetAdapter()
  {
    if (tCorrelationSetItemProvider == null)
    {
      tCorrelationSetItemProvider = new TCorrelationSetItemProvider(this);
    }

    return tCorrelationSetItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCorrelationSets} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TCorrelationSetsItemProvider tCorrelationSetsItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCorrelationSets}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTCorrelationSetsAdapter()
  {
    if (tCorrelationSetsItemProvider == null)
    {
      tCorrelationSetsItemProvider = new TCorrelationSetsItemProvider(this);
    }

    return tCorrelationSetsItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCorrelationsWithPattern} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TCorrelationsWithPatternItemProvider tCorrelationsWithPatternItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCorrelationsWithPattern}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTCorrelationsWithPatternAdapter()
  {
    if (tCorrelationsWithPatternItemProvider == null)
    {
      tCorrelationsWithPatternItemProvider = new TCorrelationsWithPatternItemProvider(this);
    }

    return tCorrelationsWithPatternItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCorrelationWithPattern} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TCorrelationWithPatternItemProvider tCorrelationWithPatternItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TCorrelationWithPattern}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTCorrelationWithPatternAdapter()
  {
    if (tCorrelationWithPatternItemProvider == null)
    {
      tCorrelationWithPatternItemProvider = new TCorrelationWithPatternItemProvider(this);
    }

    return tCorrelationWithPatternItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TEmpty} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TEmptyItemProvider tEmptyItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TEmpty}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTEmptyAdapter()
  {
    if (tEmptyItemProvider == null)
    {
      tEmptyItemProvider = new TEmptyItemProvider(this);
    }

    return tEmptyItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TEventHandlers} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TEventHandlersItemProvider tEventHandlersItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TEventHandlers}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTEventHandlersAdapter()
  {
    if (tEventHandlersItemProvider == null)
    {
      tEventHandlersItemProvider = new TEventHandlersItemProvider(this);
    }

    return tEventHandlersItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TExtensibleElements} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TExtensibleElementsItemProvider tExtensibleElementsItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TExtensibleElements}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTExtensibleElementsAdapter()
  {
    if (tExtensibleElementsItemProvider == null)
    {
      tExtensibleElementsItemProvider = new TExtensibleElementsItemProvider(this);
    }

    return tExtensibleElementsItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TFaultHandlers} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TFaultHandlersItemProvider tFaultHandlersItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TFaultHandlers}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTFaultHandlersAdapter()
  {
    if (tFaultHandlersItemProvider == null)
    {
      tFaultHandlersItemProvider = new TFaultHandlersItemProvider(this);
    }

    return tFaultHandlersItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TFlow} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TFlowItemProvider tFlowItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TFlow}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTFlowAdapter()
  {
    if (tFlowItemProvider == null)
    {
      tFlowItemProvider = new TFlowItemProvider(this);
    }

    return tFlowItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TFrom} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TFromItemProvider tFromItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TFrom}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTFromAdapter()
  {
    if (tFromItemProvider == null)
    {
      tFromItemProvider = new TFromItemProvider(this);
    }

    return tFromItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TInvoke} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TInvokeItemProvider tInvokeItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TInvoke}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTInvokeAdapter()
  {
    if (tInvokeItemProvider == null)
    {
      tInvokeItemProvider = new TInvokeItemProvider(this);
    }

    return tInvokeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TLink} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TLinkItemProvider tLinkItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TLink}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTLinkAdapter()
  {
    if (tLinkItemProvider == null)
    {
      tLinkItemProvider = new TLinkItemProvider(this);
    }

    return tLinkItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TLinks} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TLinksItemProvider tLinksItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TLinks}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTLinksAdapter()
  {
    if (tLinksItemProvider == null)
    {
      tLinksItemProvider = new TLinksItemProvider(this);
    }

    return tLinksItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TOnAlarm} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TOnAlarmItemProvider tOnAlarmItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TOnAlarm}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTOnAlarmAdapter()
  {
    if (tOnAlarmItemProvider == null)
    {
      tOnAlarmItemProvider = new TOnAlarmItemProvider(this);
    }

    return tOnAlarmItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TOnMessage} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TOnMessageItemProvider tOnMessageItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TOnMessage}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTOnMessageAdapter()
  {
    if (tOnMessageItemProvider == null)
    {
      tOnMessageItemProvider = new TOnMessageItemProvider(this);
    }

    return tOnMessageItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.ToType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ToTypeItemProvider toTypeItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.ToType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createToTypeAdapter()
  {
    if (toTypeItemProvider == null)
    {
      toTypeItemProvider = new ToTypeItemProvider(this);
    }

    return toTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TPartner} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TPartnerItemProvider tPartnerItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TPartner}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTPartnerAdapter()
  {
    if (tPartnerItemProvider == null)
    {
      tPartnerItemProvider = new TPartnerItemProvider(this);
    }

    return tPartnerItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TPartnerLink} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TPartnerLinkItemProvider tPartnerLinkItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TPartnerLink}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTPartnerLinkAdapter()
  {
    if (tPartnerLinkItemProvider == null)
    {
      tPartnerLinkItemProvider = new TPartnerLinkItemProvider(this);
    }

    return tPartnerLinkItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TPartnerLinks} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TPartnerLinksItemProvider tPartnerLinksItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TPartnerLinks}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTPartnerLinksAdapter()
  {
    if (tPartnerLinksItemProvider == null)
    {
      tPartnerLinksItemProvider = new TPartnerLinksItemProvider(this);
    }

    return tPartnerLinksItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TPartners} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TPartnersItemProvider tPartnersItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TPartners}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTPartnersAdapter()
  {
    if (tPartnersItemProvider == null)
    {
      tPartnersItemProvider = new TPartnersItemProvider(this);
    }

    return tPartnersItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TPick} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TPickItemProvider tPickItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TPick}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTPickAdapter()
  {
    if (tPickItemProvider == null)
    {
      tPickItemProvider = new TPickItemProvider(this);
    }

    return tPickItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TProcess} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TProcessItemProvider tProcessItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TProcess}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTProcessAdapter()
  {
    if (tProcessItemProvider == null)
    {
      tProcessItemProvider = new TProcessItemProvider(this);
    }

    return tProcessItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TReceive} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TReceiveItemProvider tReceiveItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TReceive}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTReceiveAdapter()
  {
    if (tReceiveItemProvider == null)
    {
      tReceiveItemProvider = new TReceiveItemProvider(this);
    }

    return tReceiveItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TReply} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TReplyItemProvider tReplyItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TReply}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTReplyAdapter()
  {
    if (tReplyItemProvider == null)
    {
      tReplyItemProvider = new TReplyItemProvider(this);
    }

    return tReplyItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TScope} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TScopeItemProvider tScopeItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TScope}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTScopeAdapter()
  {
    if (tScopeItemProvider == null)
    {
      tScopeItemProvider = new TScopeItemProvider(this);
    }

    return tScopeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TSequence} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TSequenceItemProvider tSequenceItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TSequence}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTSequenceAdapter()
  {
    if (tSequenceItemProvider == null)
    {
      tSequenceItemProvider = new TSequenceItemProvider(this);
    }

    return tSequenceItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TSource} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TSourceItemProvider tSourceItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TSource}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTSourceAdapter()
  {
    if (tSourceItemProvider == null)
    {
      tSourceItemProvider = new TSourceItemProvider(this);
    }

    return tSourceItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TSwitch} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TSwitchItemProvider tSwitchItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TSwitch}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTSwitchAdapter()
  {
    if (tSwitchItemProvider == null)
    {
      tSwitchItemProvider = new TSwitchItemProvider(this);
    }

    return tSwitchItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TTarget} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TTargetItemProvider tTargetItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TTarget}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTTargetAdapter()
  {
    if (tTargetItemProvider == null)
    {
      tTargetItemProvider = new TTargetItemProvider(this);
    }

    return tTargetItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TTerminate} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TTerminateItemProvider tTerminateItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TTerminate}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTTerminateAdapter()
  {
    if (tTerminateItemProvider == null)
    {
      tTerminateItemProvider = new TTerminateItemProvider(this);
    }

    return tTerminateItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TThrow} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TThrowItemProvider tThrowItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TThrow}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTThrowAdapter()
  {
    if (tThrowItemProvider == null)
    {
      tThrowItemProvider = new TThrowItemProvider(this);
    }

    return tThrowItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TVariable} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TVariableItemProvider tVariableItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TVariable}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTVariableAdapter()
  {
    if (tVariableItemProvider == null)
    {
      tVariableItemProvider = new TVariableItemProvider(this);
    }

    return tVariableItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TVariables} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TVariablesItemProvider tVariablesItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TVariables}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTVariablesAdapter()
  {
    if (tVariablesItemProvider == null)
    {
      tVariablesItemProvider = new TVariablesItemProvider(this);
    }

    return tVariablesItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TWait} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TWaitItemProvider tWaitItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TWait}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTWaitAdapter()
  {
    if (tWaitItemProvider == null)
    {
      tWaitItemProvider = new TWaitItemProvider(this);
    }

    return tWaitItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link org.xmlsoap.schemas.ws._2003._03.business.process.TWhile} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TWhileItemProvider tWhileItemProvider;

  /**
   * This creates an adapter for a {@link org.xmlsoap.schemas.ws._2003._03.business.process.TWhile}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTWhileAdapter()
  {
    if (tWhileItemProvider == null)
    {
      tWhileItemProvider = new TWhileItemProvider(this);
    }

    return tWhileItemProvider;
  }

  /**
   * This returns the root adapter factory that contains this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComposeableAdapterFactory getRootAdapterFactory()
  {
    return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
  }

  /**
   * This sets the composed adapter factory that contains this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
  {
    this.parentAdapterFactory = parentAdapterFactory;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isFactoryForType(Object type)
  {
    return supportedTypes.contains(type) || super.isFactoryForType(type);
  }

  /**
   * This implementation substitutes the factory itself as the key for the adapter.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter adapt(Notifier notifier, Object type)
  {
    return super.adapt(notifier, this);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object adapt(Object object, Object type)
  {
    if (isFactoryForType(type))
    {
      Object adapter = super.adapt(object, type);
      if (!(type instanceof Class) || (((Class)type).isInstance(adapter)))
      {
        return adapter;
      }
    }

    return null;
  }

  /**
   * This adds a listener.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void addListener(INotifyChangedListener notifyChangedListener)
  {
    changeNotifier.addListener(notifyChangedListener);
  }

  /**
   * This removes a listener.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void removeListener(INotifyChangedListener notifyChangedListener)
  {
    changeNotifier.removeListener(notifyChangedListener);
  }

  /**
   * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void fireNotifyChanged(Notification notification)
  {
    changeNotifier.fireNotifyChanged(notification);

    if (parentAdapterFactory != null)
    {
      parentAdapterFactory.fireNotifyChanged(notification);
    }
  }

  /**
   * This disposes all of the item providers created by this factory. 
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void dispose()
  {
    if (caseTypeItemProvider != null) caseTypeItemProvider.dispose();
    if (documentRootItemProvider != null) documentRootItemProvider.dispose();
    if (partnerLinkTypeItemProvider != null) partnerLinkTypeItemProvider.dispose();
    if (tActivityItemProvider != null) tActivityItemProvider.dispose();
    if (tActivityContainerItemProvider != null) tActivityContainerItemProvider.dispose();
    if (tActivityOrCompensateContainerItemProvider != null) tActivityOrCompensateContainerItemProvider.dispose();
    if (tAssignItemProvider != null) tAssignItemProvider.dispose();
    if (tCatchItemProvider != null) tCatchItemProvider.dispose();
    if (tCompensateItemProvider != null) tCompensateItemProvider.dispose();
    if (tCompensationHandlerItemProvider != null) tCompensationHandlerItemProvider.dispose();
    if (tCopyItemProvider != null) tCopyItemProvider.dispose();
    if (tCorrelationItemProvider != null) tCorrelationItemProvider.dispose();
    if (tCorrelationsItemProvider != null) tCorrelationsItemProvider.dispose();
    if (tCorrelationSetItemProvider != null) tCorrelationSetItemProvider.dispose();
    if (tCorrelationSetsItemProvider != null) tCorrelationSetsItemProvider.dispose();
    if (tCorrelationsWithPatternItemProvider != null) tCorrelationsWithPatternItemProvider.dispose();
    if (tCorrelationWithPatternItemProvider != null) tCorrelationWithPatternItemProvider.dispose();
    if (tEmptyItemProvider != null) tEmptyItemProvider.dispose();
    if (tEventHandlersItemProvider != null) tEventHandlersItemProvider.dispose();
    if (tExtensibleElementsItemProvider != null) tExtensibleElementsItemProvider.dispose();
    if (tFaultHandlersItemProvider != null) tFaultHandlersItemProvider.dispose();
    if (tFlowItemProvider != null) tFlowItemProvider.dispose();
    if (tFromItemProvider != null) tFromItemProvider.dispose();
    if (tInvokeItemProvider != null) tInvokeItemProvider.dispose();
    if (tLinkItemProvider != null) tLinkItemProvider.dispose();
    if (tLinksItemProvider != null) tLinksItemProvider.dispose();
    if (tOnAlarmItemProvider != null) tOnAlarmItemProvider.dispose();
    if (tOnMessageItemProvider != null) tOnMessageItemProvider.dispose();
    if (toTypeItemProvider != null) toTypeItemProvider.dispose();
    if (tPartnerItemProvider != null) tPartnerItemProvider.dispose();
    if (tPartnerLinkItemProvider != null) tPartnerLinkItemProvider.dispose();
    if (tPartnerLinksItemProvider != null) tPartnerLinksItemProvider.dispose();
    if (tPartnersItemProvider != null) tPartnersItemProvider.dispose();
    if (tPickItemProvider != null) tPickItemProvider.dispose();
    if (tProcessItemProvider != null) tProcessItemProvider.dispose();
    if (tReceiveItemProvider != null) tReceiveItemProvider.dispose();
    if (tReplyItemProvider != null) tReplyItemProvider.dispose();
    if (tScopeItemProvider != null) tScopeItemProvider.dispose();
    if (tSequenceItemProvider != null) tSequenceItemProvider.dispose();
    if (tSourceItemProvider != null) tSourceItemProvider.dispose();
    if (tSwitchItemProvider != null) tSwitchItemProvider.dispose();
    if (tTargetItemProvider != null) tTargetItemProvider.dispose();
    if (tTerminateItemProvider != null) tTerminateItemProvider.dispose();
    if (tThrowItemProvider != null) tThrowItemProvider.dispose();
    if (tVariableItemProvider != null) tVariableItemProvider.dispose();
    if (tVariablesItemProvider != null) tVariablesItemProvider.dispose();
    if (tWaitItemProvider != null) tWaitItemProvider.dispose();
    if (tWhileItemProvider != null) tWhileItemProvider.dispose();
  }

}
