/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.xmlsoap.schemas.wsdl.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.util.FeatureMapUtil;

import org.eclipse.emf.ecore.xml.type.XMLTypePackage;

import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.xmlsoap.schemas.ws._2003._03.business.process.ProcessFactory;
import org.xmlsoap.schemas.ws._2003._03.business.process.ProcessPackage;

import org.xmlsoap.schemas.ws._2003._03.business.process.provider.BPEL4WSEditPlugin;

import org.xmlsoap.schemas.wsdl.TDocumentation;
import org.xmlsoap.schemas.wsdl.WsdlFactory;
import org.xmlsoap.schemas.wsdl.WsdlPackage;

/**
 * This is the item provider adapter for a {@link org.xmlsoap.schemas.wsdl.TDocumentation} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class TDocumentationItemProvider
  extends ItemProviderAdapter
  implements	
    IEditingDomainItemProvider,	
    IStructuredItemContentProvider,	
    ITreeItemContentProvider,	
    IItemLabelProvider,	
    IItemPropertySource		
{
  /**
   * This constructs an instance from a factory and a notifier.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TDocumentationItemProvider(AdapterFactory adapterFactory)
  {
    super(adapterFactory);
  }

  /**
   * This returns the property descriptors for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public List getPropertyDescriptors(Object object)
  {
    if (itemPropertyDescriptors == null)
    {
      super.getPropertyDescriptors(object);

    }
    return itemPropertyDescriptors;
  }

  /**
   * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
   * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
   * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Collection getChildrenFeatures(Object object)
  {
    if (childrenFeatures == null)
    {
      super.getChildrenFeatures(object);
      childrenFeatures.add(WsdlPackage.Literals.TDOCUMENTATION__MIXED);
    }
    return childrenFeatures;
  }

  /**
   * This returns TDocumentation.gif.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object getImage(Object object)
  {
    return overlayImage(object, getResourceLocator().getImage("full/obj16/TDocumentation"));
  }

  /**
   * This returns the label text for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getText(Object object)
  {
    return getString("_UI_TDocumentation_type");
  }

  /**
   * This handles model notifications by calling {@link #updateChildren} to update any cached
   * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void notifyChanged(Notification notification)
  {
    updateChildren(notification);

    switch (notification.getFeatureID(TDocumentation.class))
    {
      case WsdlPackage.TDOCUMENTATION__MIXED:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
        return;
    }
    super.notifyChanged(notification);
  }

  /**
   * This adds to the collection of {@link org.eclipse.emf.edit.command.CommandParameter}s
   * describing all of the children that can be created under this object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object)
  {
    super.collectNewChildDescriptors(newChildDescriptors, object);

    newChildDescriptors.add
      (createChildParameter
        (WsdlPackage.Literals.TDOCUMENTATION__MIXED,
         FeatureMapUtil.createEntry
          (XMLTypePackage.Literals.XML_TYPE_DOCUMENT_ROOT__COMMENT,
           "")));

    newChildDescriptors.add
      (createChildParameter
        (WsdlPackage.Literals.TDOCUMENTATION__MIXED,
         FeatureMapUtil.createEntry
          (XMLTypePackage.Literals.XML_TYPE_DOCUMENT_ROOT__TEXT,
           "")));

    newChildDescriptors.add
      (createChildParameter
        (WsdlPackage.Literals.TDOCUMENTATION__MIXED,
         FeatureMapUtil.createEntry
          (XMLTypePackage.Literals.XML_TYPE_DOCUMENT_ROOT__CDATA,
           "")));

    newChildDescriptors.add
      (createChildParameter
        (WsdlPackage.Literals.TDOCUMENTATION__MIXED,
         FeatureMapUtil.createEntry
          (ProcessPackage.Literals.DOCUMENT_ROOT__FROM,
           ProcessFactory.eINSTANCE.createTFrom())));

    newChildDescriptors.add
      (createChildParameter
        (WsdlPackage.Literals.TDOCUMENTATION__MIXED,
         FeatureMapUtil.createEntry
          (ProcessPackage.Literals.DOCUMENT_ROOT__PROCESS,
           ProcessFactory.eINSTANCE.createTProcess())));

    newChildDescriptors.add
      (createChildParameter
        (WsdlPackage.Literals.TDOCUMENTATION__MIXED,
         FeatureMapUtil.createEntry
          (ProcessPackage.Literals.DOCUMENT_ROOT__TO,
           ProcessFactory.eINSTANCE.createToType())));

    newChildDescriptors.add
      (createChildParameter
        (WsdlPackage.Literals.TDOCUMENTATION__MIXED,
         FeatureMapUtil.createEntry
          (WsdlPackage.Literals.DOCUMENT_ROOT__DEFINITIONS,
           WsdlFactory.eINSTANCE.createTDefinitions())));
  }

  /**
   * Return the resource locator for this item provider's resources.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ResourceLocator getResourceLocator()
  {
    return BPEL4WSEditPlugin.INSTANCE;
  }

}
