/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package com.ibm.wbim.bom.schema1.provider;


import com.ibm.wbim.bom.schema1.DataModel;
import com.ibm.wbim.bom.schema1.Schema1Factory;
import com.ibm.wbim.bom.schema1.Schema1Package;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link com.ibm.wbim.bom.schema1.DataModel} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class DataModelItemProvider
  extends ItemProviderAdapter
  implements	
    IEditingDomainItemProvider,	
    IStructuredItemContentProvider,	
    ITreeItemContentProvider,	
    IItemLabelProvider,	
    IItemPropertySource		
{
  /**
   * This constructs an instance from a factory and a notifier.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DataModelItemProvider(AdapterFactory adapterFactory)
  {
    super(adapterFactory);
  }

  /**
   * This returns the property descriptors for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public List getPropertyDescriptors(Object object)
  {
    if (itemPropertyDescriptors == null)
    {
      super.getPropertyDescriptors(object);

    }
    return itemPropertyDescriptors;
  }

  /**
   * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
   * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
   * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Collection getChildrenFeatures(Object object)
  {
    if (childrenFeatures == null)
    {
      super.getChildrenFeatures(object);
      childrenFeatures.add(Schema1Package.Literals.DATA_MODEL__BUSINESS_ITEM_TEMPLATES);
      childrenFeatures.add(Schema1Package.Literals.DATA_MODEL__BUSINESS_ITEMS);
      childrenFeatures.add(Schema1Package.Literals.DATA_MODEL__BUSINESS_ITEM_INSTANCES);
      childrenFeatures.add(Schema1Package.Literals.DATA_MODEL__NOTIFICATION_TEMPLATES);
      childrenFeatures.add(Schema1Package.Literals.DATA_MODEL__NOTIFICATIONS);
    }
    return childrenFeatures;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected EStructuralFeature getChildFeature(Object object, Object child)
  {
    // Check the type of the specified child object and return the proper feature to use for
    // adding (see {@link AddCommand}) it as a child.

    return super.getChildFeature(object, child);
  }

  /**
   * This returns DataModel.gif.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object getImage(Object object)
  {
    return overlayImage(object, getResourceLocator().getImage("full/obj16/DataModel"));
  }

  /**
   * This returns the label text for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getText(Object object)
  {
    return getString("_UI_DataModel_type");
  }

  /**
   * This handles model notifications by calling {@link #updateChildren} to update any cached
   * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void notifyChanged(Notification notification)
  {
    updateChildren(notification);

    switch (notification.getFeatureID(DataModel.class))
    {
      case Schema1Package.DATA_MODEL__BUSINESS_ITEM_TEMPLATES:
      case Schema1Package.DATA_MODEL__BUSINESS_ITEMS:
      case Schema1Package.DATA_MODEL__BUSINESS_ITEM_INSTANCES:
      case Schema1Package.DATA_MODEL__NOTIFICATION_TEMPLATES:
      case Schema1Package.DATA_MODEL__NOTIFICATIONS:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
        return;
    }
    super.notifyChanged(notification);
  }

  /**
   * This adds to the collection of {@link org.eclipse.emf.edit.command.CommandParameter}s
   * describing all of the children that can be created under this object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object)
  {
    super.collectNewChildDescriptors(newChildDescriptors, object);

    newChildDescriptors.add
      (createChildParameter
        (Schema1Package.Literals.DATA_MODEL__BUSINESS_ITEM_TEMPLATES,
         Schema1Factory.eINSTANCE.createBusinessItemTemplatesType()));

    newChildDescriptors.add
      (createChildParameter
        (Schema1Package.Literals.DATA_MODEL__BUSINESS_ITEMS,
         Schema1Factory.eINSTANCE.createBusinessItemsType()));

    newChildDescriptors.add
      (createChildParameter
        (Schema1Package.Literals.DATA_MODEL__BUSINESS_ITEM_INSTANCES,
         Schema1Factory.eINSTANCE.createBusinessItemInstancesType()));

    newChildDescriptors.add
      (createChildParameter
        (Schema1Package.Literals.DATA_MODEL__NOTIFICATION_TEMPLATES,
         Schema1Factory.eINSTANCE.createNotificationTemplatesType()));

    newChildDescriptors.add
      (createChildParameter
        (Schema1Package.Literals.DATA_MODEL__NOTIFICATIONS,
         Schema1Factory.eINSTANCE.createNotificationsType()));
  }

  /**
   * Return the resource locator for this item provider's resources.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ResourceLocator getResourceLocator()
  {
    return WbimodelerEditPlugin.INSTANCE;
  }

}
