/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package com.ibm.wbim.bom.schema1.provider;

import com.ibm.wbim.bom.schema1.util.Schema1AdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class Schema1ItemProviderAdapterFactory extends Schema1AdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable
{
  /**
   * This keeps track of the root adapter factory that delegates to this adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ComposedAdapterFactory parentAdapterFactory;

  /**
   * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IChangeNotifier changeNotifier = new ChangeNotifier();

  /**
   * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected Collection supportedTypes = new ArrayList();

  /**
   * This constructs an instance.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Schema1ItemProviderAdapterFactory()
  {
    supportedTypes.add(IEditingDomainItemProvider.class);
    supportedTypes.add(IStructuredItemContentProvider.class);
    supportedTypes.add(ITreeItemContentProvider.class);
    supportedTypes.add(IItemLabelProvider.class);
    supportedTypes.add(IItemPropertySource.class);		
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.AdditionalInputType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AdditionalInputTypeItemProvider additionalInputTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.AdditionalInputType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createAdditionalInputTypeAdapter()
  {
    if (additionalInputTypeItemProvider == null)
    {
      additionalInputTypeItemProvider = new AdditionalInputTypeItemProvider(this);
    }

    return additionalInputTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.AdditionalOutputType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AdditionalOutputTypeItemProvider additionalOutputTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.AdditionalOutputType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createAdditionalOutputTypeAdapter()
  {
    if (additionalOutputTypeItemProvider == null)
    {
      additionalOutputTypeItemProvider = new AdditionalOutputTypeItemProvider(this);
    }

    return additionalOutputTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.AnnotatedNodeType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AnnotatedNodeTypeItemProvider annotatedNodeTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.AnnotatedNodeType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createAnnotatedNodeTypeAdapter()
  {
    if (annotatedNodeTypeItemProvider == null)
    {
      annotatedNodeTypeItemProvider = new AnnotatedNodeTypeItemProvider(this);
    }

    return annotatedNodeTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Annotation} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AnnotationItemProvider annotationItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Annotation}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createAnnotationAdapter()
  {
    if (annotationItemProvider == null)
    {
      annotationItemProvider = new AnnotationItemProvider(this);
    }

    return annotationItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Attribute} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AttributeItemProvider attributeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Attribute}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createAttributeAdapter()
  {
    if (attributeItemProvider == null)
    {
      attributeItemProvider = new AttributeItemProvider(this);
    }

    return attributeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.AttributeValue} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AttributeValueItemProvider attributeValueItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.AttributeValue}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createAttributeValueAdapter()
  {
    if (attributeValueItemProvider == null)
    {
      attributeValueItemProvider = new AttributeValueItemProvider(this);
    }

    return attributeValueItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Availability} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AvailabilityItemProvider availabilityItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Availability}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createAvailabilityAdapter()
  {
    if (availabilityItemProvider == null)
    {
      availabilityItemProvider = new AvailabilityItemProvider(this);
    }

    return availabilityItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.BasedOnTimetableType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BasedOnTimetableTypeItemProvider basedOnTimetableTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.BasedOnTimetableType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createBasedOnTimetableTypeAdapter()
  {
    if (basedOnTimetableTypeItemProvider == null)
    {
      basedOnTimetableTypeItemProvider = new BasedOnTimetableTypeItemProvider(this);
    }

    return basedOnTimetableTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.BulkResource} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BulkResourceItemProvider bulkResourceItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.BulkResource}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createBulkResourceAdapter()
  {
    if (bulkResourceItemProvider == null)
    {
      bulkResourceItemProvider = new BulkResourceItemProvider(this);
    }

    return bulkResourceItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.BulkResourceDefinitionsType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BulkResourceDefinitionsTypeItemProvider bulkResourceDefinitionsTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.BulkResourceDefinitionsType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createBulkResourceDefinitionsTypeAdapter()
  {
    if (bulkResourceDefinitionsTypeItemProvider == null)
    {
      bulkResourceDefinitionsTypeItemProvider = new BulkResourceDefinitionsTypeItemProvider(this);
    }

    return bulkResourceDefinitionsTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.BulkResourceDefinitionTemplatesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BulkResourceDefinitionTemplatesTypeItemProvider bulkResourceDefinitionTemplatesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.BulkResourceDefinitionTemplatesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createBulkResourceDefinitionTemplatesTypeAdapter()
  {
    if (bulkResourceDefinitionTemplatesTypeItemProvider == null)
    {
      bulkResourceDefinitionTemplatesTypeItemProvider = new BulkResourceDefinitionTemplatesTypeItemProvider(this);
    }

    return bulkResourceDefinitionTemplatesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.BulkResourceRequirement} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BulkResourceRequirementItemProvider bulkResourceRequirementItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.BulkResourceRequirement}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createBulkResourceRequirementAdapter()
  {
    if (bulkResourceRequirementItemProvider == null)
    {
      bulkResourceRequirementItemProvider = new BulkResourceRequirementItemProvider(this);
    }

    return bulkResourceRequirementItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.BulkResourcesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BulkResourcesTypeItemProvider bulkResourcesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.BulkResourcesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createBulkResourcesTypeAdapter()
  {
    if (bulkResourcesTypeItemProvider == null)
    {
      bulkResourcesTypeItemProvider = new BulkResourcesTypeItemProvider(this);
    }

    return bulkResourcesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.BusinessItemInstancesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BusinessItemInstancesTypeItemProvider businessItemInstancesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.BusinessItemInstancesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createBusinessItemInstancesTypeAdapter()
  {
    if (businessItemInstancesTypeItemProvider == null)
    {
      businessItemInstancesTypeItemProvider = new BusinessItemInstancesTypeItemProvider(this);
    }

    return businessItemInstancesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.BusinessItemsType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BusinessItemsTypeItemProvider businessItemsTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.BusinessItemsType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createBusinessItemsTypeAdapter()
  {
    if (businessItemsTypeItemProvider == null)
    {
      businessItemsTypeItemProvider = new BusinessItemsTypeItemProvider(this);
    }

    return businessItemsTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.BusinessItemTemplatesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BusinessItemTemplatesTypeItemProvider businessItemTemplatesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.BusinessItemTemplatesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createBusinessItemTemplatesTypeAdapter()
  {
    if (businessItemTemplatesTypeItemProvider == null)
    {
      businessItemTemplatesTypeItemProvider = new BusinessItemTemplatesTypeItemProvider(this);
    }

    return businessItemTemplatesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.CallToProcessType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CallToProcessTypeItemProvider callToProcessTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.CallToProcessType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCallToProcessTypeAdapter()
  {
    if (callToProcessTypeItemProvider == null)
    {
      callToProcessTypeItemProvider = new CallToProcessTypeItemProvider(this);
    }

    return callToProcessTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.CallToServiceType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CallToServiceTypeItemProvider callToServiceTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.CallToServiceType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCallToServiceTypeAdapter()
  {
    if (callToServiceTypeItemProvider == null)
    {
      callToServiceTypeItemProvider = new CallToServiceTypeItemProvider(this);
    }

    return callToServiceTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.CallToTaskType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CallToTaskTypeItemProvider callToTaskTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.CallToTaskType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCallToTaskTypeAdapter()
  {
    if (callToTaskTypeItemProvider == null)
    {
      callToTaskTypeItemProvider = new CallToTaskTypeItemProvider(this);
    }

    return callToTaskTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Catalog} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CatalogItemProvider catalogItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Catalog}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCatalogAdapter()
  {
    if (catalogItemProvider == null)
    {
      catalogItemProvider = new CatalogItemProvider(this);
    }

    return catalogItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Catalogs} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CatalogsItemProvider catalogsItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Catalogs}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCatalogsAdapter()
  {
    if (catalogsItemProvider == null)
    {
      catalogsItemProvider = new CatalogsItemProvider(this);
    }

    return catalogsItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.CatalogsType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CatalogsTypeItemProvider catalogsTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.CatalogsType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCatalogsTypeAdapter()
  {
    if (catalogsTypeItemProvider == null)
    {
      catalogsTypeItemProvider = new CatalogsTypeItemProvider(this);
    }

    return catalogsTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ComplexDataType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ComplexDataTypeItemProvider complexDataTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ComplexDataType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createComplexDataTypeAdapter()
  {
    if (complexDataTypeItemProvider == null)
    {
      complexDataTypeItemProvider = new ComplexDataTypeItemProvider(this);
    }

    return complexDataTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ComplexDataTypeInstance} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ComplexDataTypeInstanceItemProvider complexDataTypeInstanceItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ComplexDataTypeInstance}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createComplexDataTypeInstanceAdapter()
  {
    if (complexDataTypeInstanceItemProvider == null)
    {
      complexDataTypeInstanceItemProvider = new ComplexDataTypeInstanceItemProvider(this);
    }

    return complexDataTypeInstanceItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Connection} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ConnectionItemProvider connectionItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Connection}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createConnectionAdapter()
  {
    if (connectionItemProvider == null)
    {
      connectionItemProvider = new ConnectionItemProvider(this);
    }

    return connectionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ConstantTimeType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ConstantTimeTypeItemProvider constantTimeTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ConstantTimeType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createConstantTimeTypeAdapter()
  {
    if (constantTimeTypeItemProvider == null)
    {
      constantTimeTypeItemProvider = new ConstantTimeTypeItemProvider(this);
    }

    return constantTimeTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ControlActionOutputRef} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ControlActionOutputRefItemProvider controlActionOutputRefItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ControlActionOutputRef}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createControlActionOutputRefAdapter()
  {
    if (controlActionOutputRefItemProvider == null)
    {
      controlActionOutputRefItemProvider = new ControlActionOutputRefItemProvider(this);
    }

    return controlActionOutputRefItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.CorrelationType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CorrelationTypeItemProvider correlationTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.CorrelationType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCorrelationTypeAdapter()
  {
    if (correlationTypeItemProvider == null)
    {
      correlationTypeItemProvider = new CorrelationTypeItemProvider(this);
    }

    return correlationTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.CostPerQuantity} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CostPerQuantityItemProvider costPerQuantityItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.CostPerQuantity}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCostPerQuantityAdapter()
  {
    if (costPerQuantityItemProvider == null)
    {
      costPerQuantityItemProvider = new CostPerQuantityItemProvider(this);
    }

    return costPerQuantityItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.CostPerQuantityAndTimeUnit} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CostPerQuantityAndTimeUnitItemProvider costPerQuantityAndTimeUnitItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.CostPerQuantityAndTimeUnit}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCostPerQuantityAndTimeUnitAdapter()
  {
    if (costPerQuantityAndTimeUnitItemProvider == null)
    {
      costPerQuantityAndTimeUnitItemProvider = new CostPerQuantityAndTimeUnitItemProvider(this);
    }

    return costPerQuantityAndTimeUnitItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.CostPerTimeUnit} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CostPerTimeUnitItemProvider costPerTimeUnitItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.CostPerTimeUnit}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCostPerTimeUnitAdapter()
  {
    if (costPerTimeUnitItemProvider == null)
    {
      costPerTimeUnitItemProvider = new CostPerTimeUnitItemProvider(this);
    }

    return costPerTimeUnitItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.CostPerTimeUnitValue} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CostPerTimeUnitValueItemProvider costPerTimeUnitValueItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.CostPerTimeUnitValue}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCostPerTimeUnitValueAdapter()
  {
    if (costPerTimeUnitValueItemProvider == null)
    {
      costPerTimeUnitValueItemProvider = new CostPerTimeUnitValueItemProvider(this);
    }

    return costPerTimeUnitValueItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.CostType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CostTypeItemProvider costTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.CostType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCostTypeAdapter()
  {
    if (costTypeItemProvider == null)
    {
      costTypeItemProvider = new CostTypeItemProvider(this);
    }

    return costTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.CostValue} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CostValueItemProvider costValueItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.CostValue}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCostValueAdapter()
  {
    if (costValueItemProvider == null)
    {
      costValueItemProvider = new CostValueItemProvider(this);
    }

    return costValueItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.CriteriaTemplate} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected CriteriaTemplateItemProvider criteriaTemplateItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.CriteriaTemplate}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createCriteriaTemplateAdapter()
  {
    if (criteriaTemplateItemProvider == null)
    {
      criteriaTemplateItemProvider = new CriteriaTemplateItemProvider(this);
    }

    return criteriaTemplateItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.DataModel} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DataModelItemProvider dataModelItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.DataModel}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createDataModelAdapter()
  {
    if (dataModelItemProvider == null)
    {
      dataModelItemProvider = new DataModelItemProvider(this);
    }

    return dataModelItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Decision} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DecisionItemProvider decisionItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Decision}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createDecisionAdapter()
  {
    if (decisionItemProvider == null)
    {
      decisionItemProvider = new DecisionItemProvider(this);
    }

    return decisionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.DefaultValue} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DefaultValueItemProvider defaultValueItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.DefaultValue}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createDefaultValueAdapter()
  {
    if (defaultValueItemProvider == null)
    {
      defaultValueItemProvider = new DefaultValueItemProvider(this);
    }

    return defaultValueItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.DistributionType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DistributionTypeItemProvider distributionTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.DistributionType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createDistributionTypeAdapter()
  {
    if (distributionTypeItemProvider == null)
    {
      distributionTypeItemProvider = new DistributionTypeItemProvider(this);
    }

    return distributionTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.DistributionType1} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DistributionType1ItemProvider distributionType1ItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.DistributionType1}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createDistributionType1Adapter()
  {
    if (distributionType1ItemProvider == null)
    {
      distributionType1ItemProvider = new DistributionType1ItemProvider(this);
    }

    return distributionType1ItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.DocumentRoot} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DocumentRootItemProvider documentRootItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.DocumentRoot}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createDocumentRootAdapter()
  {
    if (documentRootItemProvider == null)
    {
      documentRootItemProvider = new DocumentRootItemProvider(this);
    }

    return documentRootItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.EndNodeType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected EndNodeTypeItemProvider endNodeTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.EndNodeType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createEndNodeTypeAdapter()
  {
    if (endNodeTypeItemProvider == null)
    {
      endNodeTypeItemProvider = new EndNodeTypeItemProvider(this);
    }

    return endNodeTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.EntryPointType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected EntryPointTypeItemProvider entryPointTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.EntryPointType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createEntryPointTypeAdapter()
  {
    if (entryPointTypeItemProvider == null)
    {
      entryPointTypeItemProvider = new EntryPointTypeItemProvider(this);
    }

    return entryPointTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ExemptionPeriodType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ExemptionPeriodTypeItemProvider exemptionPeriodTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ExemptionPeriodType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createExemptionPeriodTypeAdapter()
  {
    if (exemptionPeriodTypeItemProvider == null)
    {
      exemptionPeriodTypeItemProvider = new ExemptionPeriodTypeItemProvider(this);
    }

    return exemptionPeriodTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ExponentialType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ExponentialTypeItemProvider exponentialTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ExponentialType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createExponentialTypeAdapter()
  {
    if (exponentialTypeItemProvider == null)
    {
      exponentialTypeItemProvider = new ExponentialTypeItemProvider(this);
    }

    return exponentialTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Expression} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ExpressionItemProvider expressionItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Expression}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createExpressionAdapter()
  {
    if (expressionItemProvider == null)
    {
      expressionItemProvider = new ExpressionItemProvider(this);
    }

    return expressionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ExtendedAttributes} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ExtendedAttributesItemProvider extendedAttributesItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ExtendedAttributes}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createExtendedAttributesAdapter()
  {
    if (extendedAttributesItemProvider == null)
    {
      extendedAttributesItemProvider = new ExtendedAttributesItemProvider(this);
    }

    return extendedAttributesItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ExtendedAttributeType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ExtendedAttributeTypeItemProvider extendedAttributeTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ExtendedAttributeType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createExtendedAttributeTypeAdapter()
  {
    if (extendedAttributeTypeItemProvider == null)
    {
      extendedAttributeTypeItemProvider = new ExtendedAttributeTypeItemProvider(this);
    }

    return extendedAttributeTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.FlowContentType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FlowContentTypeItemProvider flowContentTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.FlowContentType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createFlowContentTypeAdapter()
  {
    if (flowContentTypeItemProvider == null)
    {
      flowContentTypeItemProvider = new FlowContentTypeItemProvider(this);
    }

    return flowContentTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Fork} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ForkItemProvider forkItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Fork}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createForkAdapter()
  {
    if (forkItemProvider == null)
    {
      forkItemProvider = new ForkItemProvider(this);
    }

    return forkItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ForLoop} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ForLoopItemProvider forLoopItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ForLoop}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createForLoopAdapter()
  {
    if (forLoopItemProvider == null)
    {
      forLoopItemProvider = new ForLoopItemProvider(this);
    }

    return forLoopItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.GammaType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected GammaTypeItemProvider gammaTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.GammaType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createGammaTypeAdapter()
  {
    if (gammaTypeItemProvider == null)
    {
      gammaTypeItemProvider = new GammaTypeItemProvider(this);
    }

    return gammaTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.GlobalRepositoryRef} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected GlobalRepositoryRefItemProvider globalRepositoryRefItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.GlobalRepositoryRef}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createGlobalRepositoryRefAdapter()
  {
    if (globalRepositoryRefItemProvider == null)
    {
      globalRepositoryRefItemProvider = new GlobalRepositoryRefItemProvider(this);
    }

    return globalRepositoryRefItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.GroupMembersType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected GroupMembersTypeItemProvider groupMembersTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.GroupMembersType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createGroupMembersTypeAdapter()
  {
    if (groupMembersTypeItemProvider == null)
    {
      groupMembersTypeItemProvider = new GroupMembersTypeItemProvider(this);
    }

    return groupMembersTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.GroupSearchType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected GroupSearchTypeItemProvider groupSearchTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.GroupSearchType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createGroupSearchTypeAdapter()
  {
    if (groupSearchTypeItemProvider == null)
    {
      groupSearchTypeItemProvider = new GroupSearchTypeItemProvider(this);
    }

    return groupSearchTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.IndividualResource} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IndividualResourceItemProvider individualResourceItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.IndividualResource}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createIndividualResourceAdapter()
  {
    if (individualResourceItemProvider == null)
    {
      individualResourceItemProvider = new IndividualResourceItemProvider(this);
    }

    return individualResourceItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.IndividualResourceDefinitionsType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IndividualResourceDefinitionsTypeItemProvider individualResourceDefinitionsTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.IndividualResourceDefinitionsType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createIndividualResourceDefinitionsTypeAdapter()
  {
    if (individualResourceDefinitionsTypeItemProvider == null)
    {
      individualResourceDefinitionsTypeItemProvider = new IndividualResourceDefinitionsTypeItemProvider(this);
    }

    return individualResourceDefinitionsTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.IndividualResourceDefinitionTemplatesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IndividualResourceDefinitionTemplatesTypeItemProvider individualResourceDefinitionTemplatesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.IndividualResourceDefinitionTemplatesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createIndividualResourceDefinitionTemplatesTypeAdapter()
  {
    if (individualResourceDefinitionTemplatesTypeItemProvider == null)
    {
      individualResourceDefinitionTemplatesTypeItemProvider = new IndividualResourceDefinitionTemplatesTypeItemProvider(this);
    }

    return individualResourceDefinitionTemplatesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.IndividualResourceRequirement} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IndividualResourceRequirementItemProvider individualResourceRequirementItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.IndividualResourceRequirement}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createIndividualResourceRequirementAdapter()
  {
    if (individualResourceRequirementItemProvider == null)
    {
      individualResourceRequirementItemProvider = new IndividualResourceRequirementItemProvider(this);
    }

    return individualResourceRequirementItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.IndividualResourcesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IndividualResourcesTypeItemProvider individualResourcesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.IndividualResourcesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createIndividualResourcesTypeAdapter()
  {
    if (individualResourcesTypeItemProvider == null)
    {
      individualResourcesTypeItemProvider = new IndividualResourcesTypeItemProvider(this);
    }

    return individualResourcesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Input} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected InputItemProvider inputItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Input}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createInputAdapter()
  {
    if (inputItemProvider == null)
    {
      inputItemProvider = new InputItemProvider(this);
    }

    return inputItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.InputBranch} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected InputBranchItemProvider inputBranchItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.InputBranch}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createInputBranchAdapter()
  {
    if (inputBranchItemProvider == null)
    {
      inputBranchItemProvider = new InputBranchItemProvider(this);
    }

    return inputBranchItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.InputConstantValue} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected InputConstantValueItemProvider inputConstantValueItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.InputConstantValue}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createInputConstantValueAdapter()
  {
    if (inputConstantValueItemProvider == null)
    {
      inputConstantValueItemProvider = new InputConstantValueItemProvider(this);
    }

    return inputConstantValueItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.InputConstantValueType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected InputConstantValueTypeItemProvider inputConstantValueTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.InputConstantValueType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createInputConstantValueTypeAdapter()
  {
    if (inputConstantValueTypeItemProvider == null)
    {
      inputConstantValueTypeItemProvider = new InputConstantValueTypeItemProvider(this);
    }

    return inputConstantValueTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.InputCriterion} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected InputCriterionItemProvider inputCriterionItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.InputCriterion}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createInputCriterionAdapter()
  {
    if (inputCriterionItemProvider == null)
    {
      inputCriterionItemProvider = new InputCriterionItemProvider(this);
    }

    return inputCriterionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.InputCriterionRef} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected InputCriterionRefItemProvider inputCriterionRefItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.InputCriterionRef}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createInputCriterionRefAdapter()
  {
    if (inputCriterionRefItemProvider == null)
    {
      inputCriterionRefItemProvider = new InputCriterionRefItemProvider(this);
    }

    return inputCriterionRefItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.InputRepositoryValue} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected InputRepositoryValueItemProvider inputRepositoryValueItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.InputRepositoryValue}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createInputRepositoryValueAdapter()
  {
    if (inputRepositoryValueItemProvider == null)
    {
      inputRepositoryValueItemProvider = new InputRepositoryValueItemProvider(this);
    }

    return inputRepositoryValueItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.InputRepositoryValueType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected InputRepositoryValueTypeItemProvider inputRepositoryValueTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.InputRepositoryValueType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createInputRepositoryValueTypeAdapter()
  {
    if (inputRepositoryValueTypeItemProvider == null)
    {
      inputRepositoryValueTypeItemProvider = new InputRepositoryValueTypeItemProvider(this);
    }

    return inputRepositoryValueTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Inputs} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected InputsItemProvider inputsItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Inputs}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createInputsAdapter()
  {
    if (inputsItemProvider == null)
    {
      inputsItemProvider = new InputsItemProvider(this);
    }

    return inputsItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.InputType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected InputTypeItemProvider inputTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.InputType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createInputTypeAdapter()
  {
    if (inputTypeItemProvider == null)
    {
      inputTypeItemProvider = new InputTypeItemProvider(this);
    }

    return inputTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Invocation} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected InvocationItemProvider invocationItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Invocation}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createInvocationAdapter()
  {
    if (invocationItemProvider == null)
    {
      invocationItemProvider = new InvocationItemProvider(this);
    }

    return invocationItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Join} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected JoinItemProvider joinItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Join}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createJoinAdapter()
  {
    if (joinItemProvider == null)
    {
      joinItemProvider = new JoinItemProvider(this);
    }

    return joinItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.LastActivationTimePlusType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LastActivationTimePlusTypeItemProvider lastActivationTimePlusTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.LastActivationTimePlusType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createLastActivationTimePlusTypeAdapter()
  {
    if (lastActivationTimePlusTypeItemProvider == null)
    {
      lastActivationTimePlusTypeItemProvider = new LastActivationTimePlusTypeItemProvider(this);
    }

    return lastActivationTimePlusTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.LocalRepository} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LocalRepositoryItemProvider localRepositoryItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.LocalRepository}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createLocalRepositoryAdapter()
  {
    if (localRepositoryItemProvider == null)
    {
      localRepositoryItemProvider = new LocalRepositoryItemProvider(this);
    }

    return localRepositoryItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.LocalRepositoryRef} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LocalRepositoryRefItemProvider localRepositoryRefItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.LocalRepositoryRef}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createLocalRepositoryRefAdapter()
  {
    if (localRepositoryRefItemProvider == null)
    {
      localRepositoryRefItemProvider = new LocalRepositoryRefItemProvider(this);
    }

    return localRepositoryRefItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.LocationDefinitionsType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LocationDefinitionsTypeItemProvider locationDefinitionsTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.LocationDefinitionsType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createLocationDefinitionsTypeAdapter()
  {
    if (locationDefinitionsTypeItemProvider == null)
    {
      locationDefinitionsTypeItemProvider = new LocationDefinitionsTypeItemProvider(this);
    }

    return locationDefinitionsTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.LocationDefinitionTemplatesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LocationDefinitionTemplatesTypeItemProvider locationDefinitionTemplatesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.LocationDefinitionTemplatesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createLocationDefinitionTemplatesTypeAdapter()
  {
    if (locationDefinitionTemplatesTypeItemProvider == null)
    {
      locationDefinitionTemplatesTypeItemProvider = new LocationDefinitionTemplatesTypeItemProvider(this);
    }

    return locationDefinitionTemplatesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.LocationsType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LocationsTypeItemProvider locationsTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.LocationsType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createLocationsTypeAdapter()
  {
    if (locationsTypeItemProvider == null)
    {
      locationsTypeItemProvider = new LocationsTypeItemProvider(this);
    }

    return locationsTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.LocationType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LocationTypeItemProvider locationTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.LocationType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createLocationTypeAdapter()
  {
    if (locationTypeItemProvider == null)
    {
      locationTypeItemProvider = new LocationTypeItemProvider(this);
    }

    return locationTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.LognormalType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LognormalTypeItemProvider lognormalTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.LognormalType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createLognormalTypeAdapter()
  {
    if (lognormalTypeItemProvider == null)
    {
      lognormalTypeItemProvider = new LognormalTypeItemProvider(this);
    }

    return lognormalTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Loop} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LoopItemProvider loopItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Loop}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createLoopAdapter()
  {
    if (loopItemProvider == null)
    {
      loopItemProvider = new LoopItemProvider(this);
    }

    return loopItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.LoopConditionType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LoopConditionTypeItemProvider loopConditionTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.LoopConditionType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createLoopConditionTypeAdapter()
  {
    if (loopConditionTypeItemProvider == null)
    {
      loopConditionTypeItemProvider = new LoopConditionTypeItemProvider(this);
    }

    return loopConditionTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ManagerOfEmployeeByIDType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ManagerOfEmployeeByIDTypeItemProvider managerOfEmployeeByIDTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ManagerOfEmployeeByIDType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createManagerOfEmployeeByIDTypeAdapter()
  {
    if (managerOfEmployeeByIDTypeItemProvider == null)
    {
      managerOfEmployeeByIDTypeItemProvider = new ManagerOfEmployeeByIDTypeItemProvider(this);
    }

    return managerOfEmployeeByIDTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ManagerOfEmployeeType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ManagerOfEmployeeTypeItemProvider managerOfEmployeeTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ManagerOfEmployeeType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createManagerOfEmployeeTypeAdapter()
  {
    if (managerOfEmployeeTypeItemProvider == null)
    {
      managerOfEmployeeTypeItemProvider = new ManagerOfEmployeeTypeItemProvider(this);
    }

    return managerOfEmployeeTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Map} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected MapItemProvider mapItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Map}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createMapAdapter()
  {
    if (mapItemProvider == null)
    {
      mapItemProvider = new MapItemProvider(this);
    }

    return mapItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Merge} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected MergeItemProvider mergeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Merge}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createMergeAdapter()
  {
    if (mergeItemProvider == null)
    {
      mergeItemProvider = new MergeItemProvider(this);
    }

    return mergeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ModelType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ModelTypeItemProvider modelTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ModelType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createModelTypeAdapter()
  {
    if (modelTypeItemProvider == null)
    {
      modelTypeItemProvider = new ModelTypeItemProvider(this);
    }

    return modelTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.MonetaryValue} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected MonetaryValueItemProvider monetaryValueItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.MonetaryValue}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createMonetaryValueAdapter()
  {
    if (monetaryValueItemProvider == null)
    {
      monetaryValueItemProvider = new MonetaryValueItemProvider(this);
    }

    return monetaryValueItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.NormalType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected NormalTypeItemProvider normalTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.NormalType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createNormalTypeAdapter()
  {
    if (normalTypeItemProvider == null)
    {
      normalTypeItemProvider = new NormalTypeItemProvider(this);
    }

    return normalTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.NotificationBroadcaster} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected NotificationBroadcasterItemProvider notificationBroadcasterItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.NotificationBroadcaster}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createNotificationBroadcasterAdapter()
  {
    if (notificationBroadcasterItemProvider == null)
    {
      notificationBroadcasterItemProvider = new NotificationBroadcasterItemProvider(this);
    }

    return notificationBroadcasterItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.NotificationReceiver} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected NotificationReceiverItemProvider notificationReceiverItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.NotificationReceiver}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createNotificationReceiverAdapter()
  {
    if (notificationReceiverItemProvider == null)
    {
      notificationReceiverItemProvider = new NotificationReceiverItemProvider(this);
    }

    return notificationReceiverItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.NotificationsType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected NotificationsTypeItemProvider notificationsTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.NotificationsType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createNotificationsTypeAdapter()
  {
    if (notificationsTypeItemProvider == null)
    {
      notificationsTypeItemProvider = new NotificationsTypeItemProvider(this);
    }

    return notificationsTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.NotificationTemplatesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected NotificationTemplatesTypeItemProvider notificationTemplatesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.NotificationTemplatesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createNotificationTemplatesTypeAdapter()
  {
    if (notificationTemplatesTypeItemProvider == null)
    {
      notificationTemplatesTypeItemProvider = new NotificationTemplatesTypeItemProvider(this);
    }

    return notificationTemplatesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Observer} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ObserverItemProvider observerItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Observer}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createObserverAdapter()
  {
    if (observerItemProvider == null)
    {
      observerItemProvider = new ObserverItemProvider(this);
    }

    return observerItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OneTimeCost} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OneTimeCostItemProvider oneTimeCostItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OneTimeCost}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOneTimeCostAdapter()
  {
    if (oneTimeCostItemProvider == null)
    {
      oneTimeCostItemProvider = new OneTimeCostItemProvider(this);
    }

    return oneTimeCostItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OperationalData} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OperationalDataItemProvider operationalDataItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OperationalData}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOperationalDataAdapter()
  {
    if (operationalDataItemProvider == null)
    {
      operationalDataItemProvider = new OperationalDataItemProvider(this);
    }

    return operationalDataItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OrganizationDefinitionsType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OrganizationDefinitionsTypeItemProvider organizationDefinitionsTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OrganizationDefinitionsType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOrganizationDefinitionsTypeAdapter()
  {
    if (organizationDefinitionsTypeItemProvider == null)
    {
      organizationDefinitionsTypeItemProvider = new OrganizationDefinitionsTypeItemProvider(this);
    }

    return organizationDefinitionsTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OrganizationDefinitionTemplatesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OrganizationDefinitionTemplatesTypeItemProvider organizationDefinitionTemplatesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OrganizationDefinitionTemplatesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOrganizationDefinitionTemplatesTypeAdapter()
  {
    if (organizationDefinitionTemplatesTypeItemProvider == null)
    {
      organizationDefinitionTemplatesTypeItemProvider = new OrganizationDefinitionTemplatesTypeItemProvider(this);
    }

    return organizationDefinitionTemplatesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OrganizationManagerType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OrganizationManagerTypeItemProvider organizationManagerTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OrganizationManagerType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOrganizationManagerTypeAdapter()
  {
    if (organizationManagerTypeItemProvider == null)
    {
      organizationManagerTypeItemProvider = new OrganizationManagerTypeItemProvider(this);
    }

    return organizationManagerTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OrganizationModel} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OrganizationModelItemProvider organizationModelItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OrganizationModel}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOrganizationModelAdapter()
  {
    if (organizationModelItemProvider == null)
    {
      organizationModelItemProvider = new OrganizationModelItemProvider(this);
    }

    return organizationModelItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Organizations} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OrganizationsItemProvider organizationsItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Organizations}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOrganizationsAdapter()
  {
    if (organizationsItemProvider == null)
    {
      organizationsItemProvider = new OrganizationsItemProvider(this);
    }

    return organizationsItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OrganizationUnitsType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OrganizationUnitsTypeItemProvider organizationUnitsTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OrganizationUnitsType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOrganizationUnitsTypeAdapter()
  {
    if (organizationUnitsTypeItemProvider == null)
    {
      organizationUnitsTypeItemProvider = new OrganizationUnitsTypeItemProvider(this);
    }

    return organizationUnitsTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OrganizationUnitType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OrganizationUnitTypeItemProvider organizationUnitTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OrganizationUnitType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOrganizationUnitTypeAdapter()
  {
    if (organizationUnitTypeItemProvider == null)
    {
      organizationUnitTypeItemProvider = new OrganizationUnitTypeItemProvider(this);
    }

    return organizationUnitTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Output} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OutputItemProvider outputItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Output}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOutputAdapter()
  {
    if (outputItemProvider == null)
    {
      outputItemProvider = new OutputItemProvider(this);
    }

    return outputItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OutputBranch} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OutputBranchItemProvider outputBranchItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OutputBranch}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOutputBranchAdapter()
  {
    if (outputBranchItemProvider == null)
    {
      outputBranchItemProvider = new OutputBranchItemProvider(this);
    }

    return outputBranchItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OutputBranchType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OutputBranchTypeItemProvider outputBranchTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OutputBranchType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOutputBranchTypeAdapter()
  {
    if (outputBranchTypeItemProvider == null)
    {
      outputBranchTypeItemProvider = new OutputBranchTypeItemProvider(this);
    }

    return outputBranchTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OutputCriterion} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OutputCriterionItemProvider outputCriterionItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OutputCriterion}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOutputCriterionAdapter()
  {
    if (outputCriterionItemProvider == null)
    {
      outputCriterionItemProvider = new OutputCriterionItemProvider(this);
    }

    return outputCriterionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OutputCriterionRef} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OutputCriterionRefItemProvider outputCriterionRefItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OutputCriterionRef}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOutputCriterionRefAdapter()
  {
    if (outputCriterionRefItemProvider == null)
    {
      outputCriterionRefItemProvider = new OutputCriterionRefItemProvider(this);
    }

    return outputCriterionRefItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OutputPathOperationalData} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OutputPathOperationalDataItemProvider outputPathOperationalDataItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OutputPathOperationalData}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOutputPathOperationalDataAdapter()
  {
    if (outputPathOperationalDataItemProvider == null)
    {
      outputPathOperationalDataItemProvider = new OutputPathOperationalDataItemProvider(this);
    }

    return outputPathOperationalDataItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OutputPathProbabilityValue} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OutputPathProbabilityValueItemProvider outputPathProbabilityValueItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OutputPathProbabilityValue}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOutputPathProbabilityValueAdapter()
  {
    if (outputPathProbabilityValueItemProvider == null)
    {
      outputPathProbabilityValueItemProvider = new OutputPathProbabilityValueItemProvider(this);
    }

    return outputPathProbabilityValueItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OutputRef} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OutputRefItemProvider outputRefItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OutputRef}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOutputRefAdapter()
  {
    if (outputRefItemProvider == null)
    {
      outputRefItemProvider = new OutputRefItemProvider(this);
    }

    return outputRefItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OutputRepositoryValue} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OutputRepositoryValueItemProvider outputRepositoryValueItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OutputRepositoryValue}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOutputRepositoryValueAdapter()
  {
    if (outputRepositoryValueItemProvider == null)
    {
      outputRepositoryValueItemProvider = new OutputRepositoryValueItemProvider(this);
    }

    return outputRepositoryValueItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.OutputRepositoryValueType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OutputRepositoryValueTypeItemProvider outputRepositoryValueTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.OutputRepositoryValueType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOutputRepositoryValueTypeAdapter()
  {
    if (outputRepositoryValueTypeItemProvider == null)
    {
      outputRepositoryValueTypeItemProvider = new OutputRepositoryValueTypeItemProvider(this);
    }

    return outputRepositoryValueTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Outputs} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OutputsItemProvider outputsItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Outputs}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOutputsAdapter()
  {
    if (outputsItemProvider == null)
    {
      outputsItemProvider = new OutputsItemProvider(this);
    }

    return outputsItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.PersonNameType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PersonNameTypeItemProvider personNameTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.PersonNameType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createPersonNameTypeAdapter()
  {
    if (personNameTypeItemProvider == null)
    {
      personNameTypeItemProvider = new PersonNameTypeItemProvider(this);
    }

    return personNameTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.PersonSearchType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PersonSearchTypeItemProvider personSearchTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.PersonSearchType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createPersonSearchTypeAdapter()
  {
    if (personSearchTypeItemProvider == null)
    {
      personSearchTypeItemProvider = new PersonSearchTypeItemProvider(this);
    }

    return personSearchTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.PoissonType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PoissonTypeItemProvider poissonTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.PoissonType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createPoissonTypeAdapter()
  {
    if (poissonTypeItemProvider == null)
    {
      poissonTypeItemProvider = new PoissonTypeItemProvider(this);
    }

    return poissonTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.PrivateInstance} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PrivateInstanceItemProvider privateInstanceItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.PrivateInstance}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createPrivateInstanceAdapter()
  {
    if (privateInstanceItemProvider == null)
    {
      privateInstanceItemProvider = new PrivateInstanceItemProvider(this);
    }

    return privateInstanceItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Process} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ProcessItemProvider processItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Process}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createProcessAdapter()
  {
    if (processItemProvider == null)
    {
      processItemProvider = new ProcessItemProvider(this);
    }

    return processItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ProcessesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ProcessesTypeItemProvider processesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ProcessesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createProcessesTypeAdapter()
  {
    if (processesTypeItemProvider == null)
    {
      processesTypeItemProvider = new ProcessesTypeItemProvider(this);
    }

    return processesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ProcessModel} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ProcessModelItemProvider processModelItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ProcessModel}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createProcessModelAdapter()
  {
    if (processModelItemProvider == null)
    {
      processModelItemProvider = new ProcessModelItemProvider(this);
    }

    return processModelItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.PublicInstance} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PublicInstanceItemProvider publicInstanceItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.PublicInstance}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createPublicInstanceAdapter()
  {
    if (publicInstanceItemProvider == null)
    {
      publicInstanceItemProvider = new PublicInstanceItemProvider(this);
    }

    return publicInstanceItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Qualification} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected QualificationItemProvider qualificationItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Qualification}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createQualificationAdapter()
  {
    if (qualificationItemProvider == null)
    {
      qualificationItemProvider = new QualificationItemProvider(this);
    }

    return qualificationItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Quantity} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected QuantityItemProvider quantityItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Quantity}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createQuantityAdapter()
  {
    if (quantityItemProvider == null)
    {
      quantityItemProvider = new QuantityItemProvider(this);
    }

    return quantityItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.RandomListType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RandomListTypeItemProvider randomListTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.RandomListType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createRandomListTypeAdapter()
  {
    if (randomListTypeItemProvider == null)
    {
      randomListTypeItemProvider = new RandomListTypeItemProvider(this);
    }

    return randomListTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.RecurringTimeIntervalType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RecurringTimeIntervalTypeItemProvider recurringTimeIntervalTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.RecurringTimeIntervalType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createRecurringTimeIntervalTypeAdapter()
  {
    if (recurringTimeIntervalTypeItemProvider == null)
    {
      recurringTimeIntervalTypeItemProvider = new RecurringTimeIntervalTypeItemProvider(this);
    }

    return recurringTimeIntervalTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.RelatedInputCriteriaType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RelatedInputCriteriaTypeItemProvider relatedInputCriteriaTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.RelatedInputCriteriaType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createRelatedInputCriteriaTypeAdapter()
  {
    if (relatedInputCriteriaTypeItemProvider == null)
    {
      relatedInputCriteriaTypeItemProvider = new RelatedInputCriteriaTypeItemProvider(this);
    }

    return relatedInputCriteriaTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.RepositoriesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RepositoriesTypeItemProvider repositoriesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.RepositoriesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createRepositoriesTypeAdapter()
  {
    if (repositoriesTypeItemProvider == null)
    {
      repositoriesTypeItemProvider = new RepositoriesTypeItemProvider(this);
    }

    return repositoriesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Repository} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RepositoryItemProvider repositoryItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Repository}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createRepositoryAdapter()
  {
    if (repositoryItemProvider == null)
    {
      repositoryItemProvider = new RepositoryItemProvider(this);
    }

    return repositoryItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.RepositoryDataValue} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RepositoryDataValueItemProvider repositoryDataValueItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.RepositoryDataValue}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createRepositoryDataValueAdapter()
  {
    if (repositoryDataValueItemProvider == null)
    {
      repositoryDataValueItemProvider = new RepositoryDataValueItemProvider(this);
    }

    return repositoryDataValueItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ResourceModel} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ResourceModelItemProvider resourceModelItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ResourceModel}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createResourceModelAdapter()
  {
    if (resourceModelItemProvider == null)
    {
      resourceModelItemProvider = new ResourceModelItemProvider(this);
    }

    return resourceModelItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Resources} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ResourcesItemProvider resourcesItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Resources}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createResourcesAdapter()
  {
    if (resourcesItemProvider == null)
    {
      resourcesItemProvider = new ResourcesItemProvider(this);
    }

    return resourcesItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Role} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RoleItemProvider roleItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Role}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createRoleAdapter()
  {
    if (roleItemProvider == null)
    {
      roleItemProvider = new RoleItemProvider(this);
    }

    return roleItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.RoleRequirement} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RoleRequirementItemProvider roleRequirementItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.RoleRequirement}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createRoleRequirementAdapter()
  {
    if (roleRequirementItemProvider == null)
    {
      roleRequirementItemProvider = new RoleRequirementItemProvider(this);
    }

    return roleRequirementItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.RolesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RolesTypeItemProvider rolesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.RolesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createRolesTypeAdapter()
  {
    if (rolesTypeItemProvider == null)
    {
      rolesTypeItemProvider = new RolesTypeItemProvider(this);
    }

    return rolesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ScopeDimensionType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ScopeDimensionTypeItemProvider scopeDimensionTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ScopeDimensionType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createScopeDimensionTypeAdapter()
  {
    if (scopeDimensionTypeItemProvider == null)
    {
      scopeDimensionTypeItemProvider = new ScopeDimensionTypeItemProvider(this);
    }

    return scopeDimensionTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ScopeDimensionValue} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ScopeDimensionValueItemProvider scopeDimensionValueItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ScopeDimensionValue}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createScopeDimensionValueAdapter()
  {
    if (scopeDimensionValueItemProvider == null)
    {
      scopeDimensionValueItemProvider = new ScopeDimensionValueItemProvider(this);
    }

    return scopeDimensionValueItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Service} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ServiceItemProvider serviceItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Service}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createServiceAdapter()
  {
    if (serviceItemProvider == null)
    {
      serviceItemProvider = new ServiceItemProvider(this);
    }

    return serviceItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ServicesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ServicesTypeItemProvider servicesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ServicesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createServicesTypeAdapter()
  {
    if (servicesTypeItemProvider == null)
    {
      servicesTypeItemProvider = new ServicesTypeItemProvider(this);
    }

    return servicesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.SourceType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SourceTypeItemProvider sourceTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.SourceType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createSourceTypeAdapter()
  {
    if (sourceTypeItemProvider == null)
    {
      sourceTypeItemProvider = new SourceTypeItemProvider(this);
    }

    return sourceTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.StartDayOfWeekType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected StartDayOfWeekTypeItemProvider startDayOfWeekTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.StartDayOfWeekType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createStartDayOfWeekTypeAdapter()
  {
    if (startDayOfWeekTypeItemProvider == null)
    {
      startDayOfWeekTypeItemProvider = new StartDayOfWeekTypeItemProvider(this);
    }

    return startDayOfWeekTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.StartNodeType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected StartNodeTypeItemProvider startNodeTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.StartNodeType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createStartNodeTypeAdapter()
  {
    if (startNodeTypeItemProvider == null)
    {
      startNodeTypeItemProvider = new StartNodeTypeItemProvider(this);
    }

    return startNodeTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.StopNodeType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected StopNodeTypeItemProvider stopNodeTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.StopNodeType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createStopNodeTypeAdapter()
  {
    if (stopNodeTypeItemProvider == null)
    {
      stopNodeTypeItemProvider = new StopNodeTypeItemProvider(this);
    }

    return stopNodeTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.TargetType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TargetTypeItemProvider targetTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.TargetType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTargetTypeAdapter()
  {
    if (targetTypeItemProvider == null)
    {
      targetTypeItemProvider = new TargetTypeItemProvider(this);
    }

    return targetTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Task} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TaskItemProvider taskItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Task}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTaskAdapter()
  {
    if (taskItemProvider == null)
    {
      taskItemProvider = new TaskItemProvider(this);
    }

    return taskItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.TaskIndividualResourceRequirement} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TaskIndividualResourceRequirementItemProvider taskIndividualResourceRequirementItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.TaskIndividualResourceRequirement}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTaskIndividualResourceRequirementAdapter()
  {
    if (taskIndividualResourceRequirementItemProvider == null)
    {
      taskIndividualResourceRequirementItemProvider = new TaskIndividualResourceRequirementItemProvider(this);
    }

    return taskIndividualResourceRequirementItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.TasksType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TasksTypeItemProvider tasksTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.TasksType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTasksTypeAdapter()
  {
    if (tasksTypeItemProvider == null)
    {
      tasksTypeItemProvider = new TasksTypeItemProvider(this);
    }

    return tasksTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.TimeEstimationType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TimeEstimationTypeItemProvider timeEstimationTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.TimeEstimationType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTimeEstimationTypeAdapter()
  {
    if (timeEstimationTypeItemProvider == null)
    {
      timeEstimationTypeItemProvider = new TimeEstimationTypeItemProvider(this);
    }

    return timeEstimationTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Timer} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TimerItemProvider timerItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Timer}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTimerAdapter()
  {
    if (timerItemProvider == null)
    {
      timerItemProvider = new TimerItemProvider(this);
    }

    return timerItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.TimerSettingType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TimerSettingTypeItemProvider timerSettingTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.TimerSettingType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTimerSettingTypeAdapter()
  {
    if (timerSettingTypeItemProvider == null)
    {
      timerSettingTypeItemProvider = new TimerSettingTypeItemProvider(this);
    }

    return timerSettingTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.Timetable} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TimetableItemProvider timetableItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.Timetable}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTimetableAdapter()
  {
    if (timetableItemProvider == null)
    {
      timetableItemProvider = new TimetableItemProvider(this);
    }

    return timetableItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.TimetablesType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TimetablesTypeItemProvider timetablesTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.TimetablesType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTimetablesTypeAdapter()
  {
    if (timetablesTypeItemProvider == null)
    {
      timetablesTypeItemProvider = new TimetablesTypeItemProvider(this);
    }

    return timetablesTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.TimeValue} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TimeValueItemProvider timeValueItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.TimeValue}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTimeValueAdapter()
  {
    if (timeValueItemProvider == null)
    {
      timeValueItemProvider = new TimeValueItemProvider(this);
    }

    return timeValueItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.TypeDeclaration} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TypeDeclarationItemProvider typeDeclarationItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.TypeDeclaration}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTypeDeclarationAdapter()
  {
    if (typeDeclarationItemProvider == null)
    {
      typeDeclarationItemProvider = new TypeDeclarationItemProvider(this);
    }

    return typeDeclarationItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.UniformType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected UniformTypeItemProvider uniformTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.UniformType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createUniformTypeAdapter()
  {
    if (uniformTypeItemProvider == null)
    {
      uniformTypeItemProvider = new UniformTypeItemProvider(this);
    }

    return uniformTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.ValueType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ValueTypeItemProvider valueTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.ValueType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createValueTypeAdapter()
  {
    if (valueTypeItemProvider == null)
    {
      valueTypeItemProvider = new ValueTypeItemProvider(this);
    }

    return valueTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.WeightedListType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected WeightedListTypeItemProvider weightedListTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.WeightedListType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createWeightedListTypeAdapter()
  {
    if (weightedListTypeItemProvider == null)
    {
      weightedListTypeItemProvider = new WeightedListTypeItemProvider(this);
    }

    return weightedListTypeItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link com.ibm.wbim.bom.schema1.WhenCostApplicableType} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected WhenCostApplicableTypeItemProvider whenCostApplicableTypeItemProvider;

  /**
   * This creates an adapter for a {@link com.ibm.wbim.bom.schema1.WhenCostApplicableType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createWhenCostApplicableTypeAdapter()
  {
    if (whenCostApplicableTypeItemProvider == null)
    {
      whenCostApplicableTypeItemProvider = new WhenCostApplicableTypeItemProvider(this);
    }

    return whenCostApplicableTypeItemProvider;
  }

  /**
   * This returns the root adapter factory that contains this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComposeableAdapterFactory getRootAdapterFactory()
  {
    return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
  }

  /**
   * This sets the composed adapter factory that contains this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
  {
    this.parentAdapterFactory = parentAdapterFactory;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isFactoryForType(Object type)
  {
    return supportedTypes.contains(type) || super.isFactoryForType(type);
  }

  /**
   * This implementation substitutes the factory itself as the key for the adapter.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter adapt(Notifier notifier, Object type)
  {
    return super.adapt(notifier, this);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object adapt(Object object, Object type)
  {
    if (isFactoryForType(type))
    {
      Object adapter = super.adapt(object, type);
      if (!(type instanceof Class) || (((Class)type).isInstance(adapter)))
      {
        return adapter;
      }
    }

    return null;
  }

  /**
   * This adds a listener.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void addListener(INotifyChangedListener notifyChangedListener)
  {
    changeNotifier.addListener(notifyChangedListener);
  }

  /**
   * This removes a listener.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void removeListener(INotifyChangedListener notifyChangedListener)
  {
    changeNotifier.removeListener(notifyChangedListener);
  }

  /**
   * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void fireNotifyChanged(Notification notification)
  {
    changeNotifier.fireNotifyChanged(notification);

    if (parentAdapterFactory != null)
    {
      parentAdapterFactory.fireNotifyChanged(notification);
    }
  }

  /**
   * This disposes all of the item providers created by this factory. 
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void dispose()
  {
    if (additionalInputTypeItemProvider != null) additionalInputTypeItemProvider.dispose();
    if (additionalOutputTypeItemProvider != null) additionalOutputTypeItemProvider.dispose();
    if (annotatedNodeTypeItemProvider != null) annotatedNodeTypeItemProvider.dispose();
    if (annotationItemProvider != null) annotationItemProvider.dispose();
    if (attributeItemProvider != null) attributeItemProvider.dispose();
    if (attributeValueItemProvider != null) attributeValueItemProvider.dispose();
    if (availabilityItemProvider != null) availabilityItemProvider.dispose();
    if (basedOnTimetableTypeItemProvider != null) basedOnTimetableTypeItemProvider.dispose();
    if (bulkResourceItemProvider != null) bulkResourceItemProvider.dispose();
    if (bulkResourceDefinitionsTypeItemProvider != null) bulkResourceDefinitionsTypeItemProvider.dispose();
    if (bulkResourceDefinitionTemplatesTypeItemProvider != null) bulkResourceDefinitionTemplatesTypeItemProvider.dispose();
    if (bulkResourceRequirementItemProvider != null) bulkResourceRequirementItemProvider.dispose();
    if (bulkResourcesTypeItemProvider != null) bulkResourcesTypeItemProvider.dispose();
    if (businessItemInstancesTypeItemProvider != null) businessItemInstancesTypeItemProvider.dispose();
    if (businessItemsTypeItemProvider != null) businessItemsTypeItemProvider.dispose();
    if (businessItemTemplatesTypeItemProvider != null) businessItemTemplatesTypeItemProvider.dispose();
    if (callToProcessTypeItemProvider != null) callToProcessTypeItemProvider.dispose();
    if (callToServiceTypeItemProvider != null) callToServiceTypeItemProvider.dispose();
    if (callToTaskTypeItemProvider != null) callToTaskTypeItemProvider.dispose();
    if (catalogItemProvider != null) catalogItemProvider.dispose();
    if (catalogsItemProvider != null) catalogsItemProvider.dispose();
    if (catalogsTypeItemProvider != null) catalogsTypeItemProvider.dispose();
    if (complexDataTypeItemProvider != null) complexDataTypeItemProvider.dispose();
    if (complexDataTypeInstanceItemProvider != null) complexDataTypeInstanceItemProvider.dispose();
    if (connectionItemProvider != null) connectionItemProvider.dispose();
    if (constantTimeTypeItemProvider != null) constantTimeTypeItemProvider.dispose();
    if (controlActionOutputRefItemProvider != null) controlActionOutputRefItemProvider.dispose();
    if (correlationTypeItemProvider != null) correlationTypeItemProvider.dispose();
    if (costPerQuantityItemProvider != null) costPerQuantityItemProvider.dispose();
    if (costPerQuantityAndTimeUnitItemProvider != null) costPerQuantityAndTimeUnitItemProvider.dispose();
    if (costPerTimeUnitItemProvider != null) costPerTimeUnitItemProvider.dispose();
    if (costPerTimeUnitValueItemProvider != null) costPerTimeUnitValueItemProvider.dispose();
    if (costTypeItemProvider != null) costTypeItemProvider.dispose();
    if (costValueItemProvider != null) costValueItemProvider.dispose();
    if (criteriaTemplateItemProvider != null) criteriaTemplateItemProvider.dispose();
    if (dataModelItemProvider != null) dataModelItemProvider.dispose();
    if (decisionItemProvider != null) decisionItemProvider.dispose();
    if (defaultValueItemProvider != null) defaultValueItemProvider.dispose();
    if (distributionTypeItemProvider != null) distributionTypeItemProvider.dispose();
    if (distributionType1ItemProvider != null) distributionType1ItemProvider.dispose();
    if (documentRootItemProvider != null) documentRootItemProvider.dispose();
    if (endNodeTypeItemProvider != null) endNodeTypeItemProvider.dispose();
    if (entryPointTypeItemProvider != null) entryPointTypeItemProvider.dispose();
    if (exemptionPeriodTypeItemProvider != null) exemptionPeriodTypeItemProvider.dispose();
    if (exponentialTypeItemProvider != null) exponentialTypeItemProvider.dispose();
    if (expressionItemProvider != null) expressionItemProvider.dispose();
    if (extendedAttributesItemProvider != null) extendedAttributesItemProvider.dispose();
    if (extendedAttributeTypeItemProvider != null) extendedAttributeTypeItemProvider.dispose();
    if (flowContentTypeItemProvider != null) flowContentTypeItemProvider.dispose();
    if (forkItemProvider != null) forkItemProvider.dispose();
    if (forLoopItemProvider != null) forLoopItemProvider.dispose();
    if (gammaTypeItemProvider != null) gammaTypeItemProvider.dispose();
    if (globalRepositoryRefItemProvider != null) globalRepositoryRefItemProvider.dispose();
    if (groupMembersTypeItemProvider != null) groupMembersTypeItemProvider.dispose();
    if (groupSearchTypeItemProvider != null) groupSearchTypeItemProvider.dispose();
    if (individualResourceItemProvider != null) individualResourceItemProvider.dispose();
    if (individualResourceDefinitionsTypeItemProvider != null) individualResourceDefinitionsTypeItemProvider.dispose();
    if (individualResourceDefinitionTemplatesTypeItemProvider != null) individualResourceDefinitionTemplatesTypeItemProvider.dispose();
    if (individualResourceRequirementItemProvider != null) individualResourceRequirementItemProvider.dispose();
    if (individualResourcesTypeItemProvider != null) individualResourcesTypeItemProvider.dispose();
    if (inputItemProvider != null) inputItemProvider.dispose();
    if (inputBranchItemProvider != null) inputBranchItemProvider.dispose();
    if (inputConstantValueItemProvider != null) inputConstantValueItemProvider.dispose();
    if (inputConstantValueTypeItemProvider != null) inputConstantValueTypeItemProvider.dispose();
    if (inputCriterionItemProvider != null) inputCriterionItemProvider.dispose();
    if (inputCriterionRefItemProvider != null) inputCriterionRefItemProvider.dispose();
    if (inputRepositoryValueItemProvider != null) inputRepositoryValueItemProvider.dispose();
    if (inputRepositoryValueTypeItemProvider != null) inputRepositoryValueTypeItemProvider.dispose();
    if (inputsItemProvider != null) inputsItemProvider.dispose();
    if (inputTypeItemProvider != null) inputTypeItemProvider.dispose();
    if (invocationItemProvider != null) invocationItemProvider.dispose();
    if (joinItemProvider != null) joinItemProvider.dispose();
    if (lastActivationTimePlusTypeItemProvider != null) lastActivationTimePlusTypeItemProvider.dispose();
    if (localRepositoryItemProvider != null) localRepositoryItemProvider.dispose();
    if (localRepositoryRefItemProvider != null) localRepositoryRefItemProvider.dispose();
    if (locationDefinitionsTypeItemProvider != null) locationDefinitionsTypeItemProvider.dispose();
    if (locationDefinitionTemplatesTypeItemProvider != null) locationDefinitionTemplatesTypeItemProvider.dispose();
    if (locationsTypeItemProvider != null) locationsTypeItemProvider.dispose();
    if (locationTypeItemProvider != null) locationTypeItemProvider.dispose();
    if (lognormalTypeItemProvider != null) lognormalTypeItemProvider.dispose();
    if (loopItemProvider != null) loopItemProvider.dispose();
    if (loopConditionTypeItemProvider != null) loopConditionTypeItemProvider.dispose();
    if (managerOfEmployeeByIDTypeItemProvider != null) managerOfEmployeeByIDTypeItemProvider.dispose();
    if (managerOfEmployeeTypeItemProvider != null) managerOfEmployeeTypeItemProvider.dispose();
    if (mapItemProvider != null) mapItemProvider.dispose();
    if (mergeItemProvider != null) mergeItemProvider.dispose();
    if (modelTypeItemProvider != null) modelTypeItemProvider.dispose();
    if (monetaryValueItemProvider != null) monetaryValueItemProvider.dispose();
    if (normalTypeItemProvider != null) normalTypeItemProvider.dispose();
    if (notificationBroadcasterItemProvider != null) notificationBroadcasterItemProvider.dispose();
    if (notificationReceiverItemProvider != null) notificationReceiverItemProvider.dispose();
    if (notificationsTypeItemProvider != null) notificationsTypeItemProvider.dispose();
    if (notificationTemplatesTypeItemProvider != null) notificationTemplatesTypeItemProvider.dispose();
    if (observerItemProvider != null) observerItemProvider.dispose();
    if (oneTimeCostItemProvider != null) oneTimeCostItemProvider.dispose();
    if (operationalDataItemProvider != null) operationalDataItemProvider.dispose();
    if (organizationDefinitionsTypeItemProvider != null) organizationDefinitionsTypeItemProvider.dispose();
    if (organizationDefinitionTemplatesTypeItemProvider != null) organizationDefinitionTemplatesTypeItemProvider.dispose();
    if (organizationManagerTypeItemProvider != null) organizationManagerTypeItemProvider.dispose();
    if (organizationModelItemProvider != null) organizationModelItemProvider.dispose();
    if (organizationsItemProvider != null) organizationsItemProvider.dispose();
    if (organizationUnitsTypeItemProvider != null) organizationUnitsTypeItemProvider.dispose();
    if (organizationUnitTypeItemProvider != null) organizationUnitTypeItemProvider.dispose();
    if (outputItemProvider != null) outputItemProvider.dispose();
    if (outputBranchItemProvider != null) outputBranchItemProvider.dispose();
    if (outputBranchTypeItemProvider != null) outputBranchTypeItemProvider.dispose();
    if (outputCriterionItemProvider != null) outputCriterionItemProvider.dispose();
    if (outputCriterionRefItemProvider != null) outputCriterionRefItemProvider.dispose();
    if (outputPathOperationalDataItemProvider != null) outputPathOperationalDataItemProvider.dispose();
    if (outputPathProbabilityValueItemProvider != null) outputPathProbabilityValueItemProvider.dispose();
    if (outputRefItemProvider != null) outputRefItemProvider.dispose();
    if (outputRepositoryValueItemProvider != null) outputRepositoryValueItemProvider.dispose();
    if (outputRepositoryValueTypeItemProvider != null) outputRepositoryValueTypeItemProvider.dispose();
    if (outputsItemProvider != null) outputsItemProvider.dispose();
    if (personNameTypeItemProvider != null) personNameTypeItemProvider.dispose();
    if (personSearchTypeItemProvider != null) personSearchTypeItemProvider.dispose();
    if (poissonTypeItemProvider != null) poissonTypeItemProvider.dispose();
    if (privateInstanceItemProvider != null) privateInstanceItemProvider.dispose();
    if (processItemProvider != null) processItemProvider.dispose();
    if (processesTypeItemProvider != null) processesTypeItemProvider.dispose();
    if (processModelItemProvider != null) processModelItemProvider.dispose();
    if (publicInstanceItemProvider != null) publicInstanceItemProvider.dispose();
    if (qualificationItemProvider != null) qualificationItemProvider.dispose();
    if (quantityItemProvider != null) quantityItemProvider.dispose();
    if (randomListTypeItemProvider != null) randomListTypeItemProvider.dispose();
    if (recurringTimeIntervalTypeItemProvider != null) recurringTimeIntervalTypeItemProvider.dispose();
    if (relatedInputCriteriaTypeItemProvider != null) relatedInputCriteriaTypeItemProvider.dispose();
    if (repositoriesTypeItemProvider != null) repositoriesTypeItemProvider.dispose();
    if (repositoryItemProvider != null) repositoryItemProvider.dispose();
    if (repositoryDataValueItemProvider != null) repositoryDataValueItemProvider.dispose();
    if (resourceModelItemProvider != null) resourceModelItemProvider.dispose();
    if (resourcesItemProvider != null) resourcesItemProvider.dispose();
    if (roleItemProvider != null) roleItemProvider.dispose();
    if (roleRequirementItemProvider != null) roleRequirementItemProvider.dispose();
    if (rolesTypeItemProvider != null) rolesTypeItemProvider.dispose();
    if (scopeDimensionTypeItemProvider != null) scopeDimensionTypeItemProvider.dispose();
    if (scopeDimensionValueItemProvider != null) scopeDimensionValueItemProvider.dispose();
    if (serviceItemProvider != null) serviceItemProvider.dispose();
    if (servicesTypeItemProvider != null) servicesTypeItemProvider.dispose();
    if (sourceTypeItemProvider != null) sourceTypeItemProvider.dispose();
    if (startDayOfWeekTypeItemProvider != null) startDayOfWeekTypeItemProvider.dispose();
    if (startNodeTypeItemProvider != null) startNodeTypeItemProvider.dispose();
    if (stopNodeTypeItemProvider != null) stopNodeTypeItemProvider.dispose();
    if (targetTypeItemProvider != null) targetTypeItemProvider.dispose();
    if (taskItemProvider != null) taskItemProvider.dispose();
    if (taskIndividualResourceRequirementItemProvider != null) taskIndividualResourceRequirementItemProvider.dispose();
    if (tasksTypeItemProvider != null) tasksTypeItemProvider.dispose();
    if (timeEstimationTypeItemProvider != null) timeEstimationTypeItemProvider.dispose();
    if (timerItemProvider != null) timerItemProvider.dispose();
    if (timerSettingTypeItemProvider != null) timerSettingTypeItemProvider.dispose();
    if (timetableItemProvider != null) timetableItemProvider.dispose();
    if (timetablesTypeItemProvider != null) timetablesTypeItemProvider.dispose();
    if (timeValueItemProvider != null) timeValueItemProvider.dispose();
    if (typeDeclarationItemProvider != null) typeDeclarationItemProvider.dispose();
    if (uniformTypeItemProvider != null) uniformTypeItemProvider.dispose();
    if (valueTypeItemProvider != null) valueTypeItemProvider.dispose();
    if (weightedListTypeItemProvider != null) weightedListTypeItemProvider.dispose();
    if (whenCostApplicableTypeItemProvider != null) whenCostApplicableTypeItemProvider.dispose();
  }

}
