/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package com.ibm.wbim.bom.schema1.provider;


import com.ibm.wbim.bom.schema1.Schema1Factory;
import com.ibm.wbim.bom.schema1.Schema1Package;
import com.ibm.wbim.bom.schema1.Task;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link com.ibm.wbim.bom.schema1.Task} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class TaskItemProvider
  extends ItemProviderAdapter
  implements	
    IEditingDomainItemProvider,	
    IStructuredItemContentProvider,	
    ITreeItemContentProvider,	
    IItemLabelProvider,	
    IItemPropertySource		
{
  /**
   * This constructs an instance from a factory and a notifier.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TaskItemProvider(AdapterFactory adapterFactory)
  {
    super(adapterFactory);
  }

  /**
   * This returns the property descriptors for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public List getPropertyDescriptors(Object object)
  {
    if (itemPropertyDescriptors == null)
    {
      super.getPropertyDescriptors(object);

      addDescriptionPropertyDescriptor(object);
      addNamePropertyDescriptor(object);
    }
    return itemPropertyDescriptors;
  }

  /**
   * This adds a property descriptor for the Description feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addDescriptionPropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_Task_description_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_Task_description_feature", "_UI_Task_type"),
         Schema1Package.Literals.TASK__DESCRIPTION,
         true,
         false,
         false,
         ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
         null,
         null));
  }

  /**
   * This adds a property descriptor for the Name feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addNamePropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_Task_name_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_Task_name_feature", "_UI_Task_type"),
         Schema1Package.Literals.TASK__NAME,
         true,
         false,
         false,
         ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
         null,
         null));
  }

  /**
   * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
   * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
   * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Collection getChildrenFeatures(Object object)
  {
    if (childrenFeatures == null)
    {
      super.getChildrenFeatures(object);
      childrenFeatures.add(Schema1Package.Literals.TASK__INPUTS);
      childrenFeatures.add(Schema1Package.Literals.TASK__OUTPUTS);
      childrenFeatures.add(Schema1Package.Literals.TASK__PRECONDITION);
      childrenFeatures.add(Schema1Package.Literals.TASK__POSTCONDITION);
      childrenFeatures.add(Schema1Package.Literals.TASK__RESOURCES);
      childrenFeatures.add(Schema1Package.Literals.TASK__ORGANIZATIONS);
      childrenFeatures.add(Schema1Package.Literals.TASK__OPERATIONAL_DATA);
      childrenFeatures.add(Schema1Package.Literals.TASK__EXTENDED_ATTRIBUTES);
    }
    return childrenFeatures;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected EStructuralFeature getChildFeature(Object object, Object child)
  {
    // Check the type of the specified child object and return the proper feature to use for
    // adding (see {@link AddCommand}) it as a child.

    return super.getChildFeature(object, child);
  }

  /**
   * This returns Task.gif.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object getImage(Object object)
  {
    return overlayImage(object, getResourceLocator().getImage("full/obj16/Task"));
  }

  /**
   * This returns the label text for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getText(Object object)
  {
    String label = ((Task)object).getName();
    return label == null || label.length() == 0 ?
      getString("_UI_Task_type") :
      getString("_UI_Task_type") + " " + label;
  }

  /**
   * This handles model notifications by calling {@link #updateChildren} to update any cached
   * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void notifyChanged(Notification notification)
  {
    updateChildren(notification);

    switch (notification.getFeatureID(Task.class))
    {
      case Schema1Package.TASK__DESCRIPTION:
      case Schema1Package.TASK__NAME:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
        return;
      case Schema1Package.TASK__INPUTS:
      case Schema1Package.TASK__OUTPUTS:
      case Schema1Package.TASK__PRECONDITION:
      case Schema1Package.TASK__POSTCONDITION:
      case Schema1Package.TASK__RESOURCES:
      case Schema1Package.TASK__ORGANIZATIONS:
      case Schema1Package.TASK__OPERATIONAL_DATA:
      case Schema1Package.TASK__EXTENDED_ATTRIBUTES:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
        return;
    }
    super.notifyChanged(notification);
  }

  /**
   * This adds to the collection of {@link org.eclipse.emf.edit.command.CommandParameter}s
   * describing all of the children that can be created under this object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object)
  {
    super.collectNewChildDescriptors(newChildDescriptors, object);

    newChildDescriptors.add
      (createChildParameter
        (Schema1Package.Literals.TASK__INPUTS,
         Schema1Factory.eINSTANCE.createInputs()));

    newChildDescriptors.add
      (createChildParameter
        (Schema1Package.Literals.TASK__OUTPUTS,
         Schema1Factory.eINSTANCE.createOutputs()));

    newChildDescriptors.add
      (createChildParameter
        (Schema1Package.Literals.TASK__PRECONDITION,
         Schema1Factory.eINSTANCE.createExpression()));

    newChildDescriptors.add
      (createChildParameter
        (Schema1Package.Literals.TASK__POSTCONDITION,
         Schema1Factory.eINSTANCE.createExpression()));

    newChildDescriptors.add
      (createChildParameter
        (Schema1Package.Literals.TASK__RESOURCES,
         Schema1Factory.eINSTANCE.createResources()));

    newChildDescriptors.add
      (createChildParameter
        (Schema1Package.Literals.TASK__ORGANIZATIONS,
         Schema1Factory.eINSTANCE.createOrganizations()));

    newChildDescriptors.add
      (createChildParameter
        (Schema1Package.Literals.TASK__OPERATIONAL_DATA,
         Schema1Factory.eINSTANCE.createOperationalData()));

    newChildDescriptors.add
      (createChildParameter
        (Schema1Package.Literals.TASK__EXTENDED_ATTRIBUTES,
         Schema1Factory.eINSTANCE.createExtendedAttributes()));
  }

  /**
   * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getCreateChildText(Object owner, Object feature, Object child, Collection selection)
  {
    Object childFeature = feature;
    Object childObject = child;

    boolean qualify =
      childFeature == Schema1Package.Literals.TASK__PRECONDITION ||
      childFeature == Schema1Package.Literals.TASK__POSTCONDITION;

    if (qualify)
    {
      return getString
        ("_UI_CreateChild_text2",
         new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
    }
    return super.getCreateChildText(owner, feature, child, selection);
  }

  /**
   * Return the resource locator for this item provider's resources.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ResourceLocator getResourceLocator()
  {
    return WbimodelerEditPlugin.INSTANCE;
  }

}
