<?xml version="1.0"?>
<!-- convert generated XMI into WBI XML -->
<xsl:stylesheet version="1.0"
  xmlns:xmi="http://www.omg.org/XMI"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns="http://schemas.xmlsoap.org/ws/2003/03/business-process/"
  xmlns:bpws="http://schemas.xmlsoap.org/ws/2003/03/business-process/">
  <xsl:output method="xml" indent="yes" />
  <xsl:strip-space elements="*"/>
  <xsl:template match="/">
	  <xsl:for-each select="bpws:TProcess">
		<xsl:apply-templates select="."/>
	  </xsl:for-each>
  </xsl:template>
  <xsl:template match="bpws:TProcess">
     <bpws:process>
  	  <xsl:for-each select="@*">
  	    <xsl:if test="substring-before(name(),':') != 'xmi'">
  	    <xsl:attribute name="{name()}">
			<xsl:value-of select="."/>
	    </xsl:attribute>
	    </xsl:if>
	  </xsl:for-each>
	  <xsl:for-each select="*">
		<xsl:apply-templates select="."/>
	  </xsl:for-each>
	 </bpws:process>
  </xsl:template>
  <xsl:template match="*">
	<xsl:element name="{local-name()}">
  	   <xsl:for-each select="@*">
		<xsl:attribute name="{local-name()}">
			<xsl:value-of select="."/>
		</xsl:attribute>
  	   </xsl:for-each>
  	   <xsl:for-each select="*">
		<xsl:apply-templates select="."/>
  	   </xsl:for-each>
	</xsl:element>
  </xsl:template>
</xsl:stylesheet>
