/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package edu.toronto.cs.istar.provider;


import edu.toronto.cs.istar.Actor;
import edu.toronto.cs.istar.IstarFactory;
import edu.toronto.cs.istar.IstarPackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link edu.toronto.cs.istar.Actor} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ActorItemProvider
  extends ItemProviderAdapter
  implements	
    IEditingDomainItemProvider,	
    IStructuredItemContentProvider,	
    ITreeItemContentProvider,	
    IItemLabelProvider,	
    IItemPropertySource		
{
  /**
   * This constructs an instance from a factory and a notifier.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ActorItemProvider(AdapterFactory adapterFactory)
  {
    super(adapterFactory);
  }

  /**
   * This returns the property descriptors for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public List getPropertyDescriptors(Object object)
  {
    if (itemPropertyDescriptors == null)
    {
      super.getPropertyDescriptors(object);

      addNamePropertyDescriptor(object);
      addAllIntentionsPropertyDescriptor(object);
    }
    return itemPropertyDescriptors;
  }

  /**
   * This adds a property descriptor for the Name feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addNamePropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_Actor_name_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_Actor_name_feature", "_UI_Actor_type"),
         IstarPackage.Literals.ACTOR__NAME,
         true,
         false,
         false,
         ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
         null,
         null));
  }

  /**
   * This adds a property descriptor for the All Intentions feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addAllIntentionsPropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_Actor_allIntentions_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_Actor_allIntentions_feature", "_UI_Actor_type"),
         IstarPackage.Literals.ACTOR__ALL_INTENTIONS,
         false,
         false,
         false,
         null,
         null,
         null));
  }

  /**
   * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
   * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
   * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Collection getChildrenFeatures(Object object)
  {
    if (childrenFeatures == null)
    {
      super.getChildrenFeatures(object);
      childrenFeatures.add(IstarPackage.Literals.ACTOR__INTENTIONS);
      childrenFeatures.add(IstarPackage.Literals.ACTOR__RELATION_FROM);
      childrenFeatures.add(IstarPackage.Literals.ACTOR__RELATION_TO);
    }
    return childrenFeatures;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected EStructuralFeature getChildFeature(Object object, Object child)
  {
    // Check the type of the specified child object and return the proper feature to use for
    // adding (see {@link AddCommand}) it as a child.

    return super.getChildFeature(object, child);
  }

  /**
   * This returns Actor.gif.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object getImage(Object object)
  {
    return overlayImage(object, getResourceLocator().getImage("full/obj16/Actor"));
  }

  /**
   * This returns the label text for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getText(Object object)
  {
    String label = ((Actor)object).getName();
    return label == null || label.length() == 0 ?
      getString("_UI_Actor_type") :
      getString("_UI_Actor_type") + " " + label;
  }

  /**
   * This handles model notifications by calling {@link #updateChildren} to update any cached
   * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void notifyChanged(Notification notification)
  {
    updateChildren(notification);

    switch (notification.getFeatureID(Actor.class))
    {
      case IstarPackage.ACTOR__NAME:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
        return;
      case IstarPackage.ACTOR__INTENTIONS:
      case IstarPackage.ACTOR__RELATION_FROM:
      case IstarPackage.ACTOR__RELATION_TO:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
        return;
    }
    super.notifyChanged(notification);
  }

  /**
   * This adds to the collection of {@link org.eclipse.emf.edit.command.CommandParameter}s
   * describing all of the children that can be created under this object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object)
  {
    super.collectNewChildDescriptors(newChildDescriptors, object);

    newChildDescriptors.add
      (createChildParameter
        (IstarPackage.Literals.ACTOR__INTENTIONS,
         IstarFactory.eINSTANCE.createIntention()));

    newChildDescriptors.add
      (createChildParameter
        (IstarPackage.Literals.ACTOR__INTENTIONS,
         IstarFactory.eINSTANCE.createGoal()));

    newChildDescriptors.add
      (createChildParameter
        (IstarPackage.Literals.ACTOR__INTENTIONS,
         IstarFactory.eINSTANCE.createResource()));

    newChildDescriptors.add
      (createChildParameter
        (IstarPackage.Literals.ACTOR__INTENTIONS,
         IstarFactory.eINSTANCE.createTask()));

    newChildDescriptors.add
      (createChildParameter
        (IstarPackage.Literals.ACTOR__INTENTIONS,
         IstarFactory.eINSTANCE.createSoftGoal()));

    newChildDescriptors.add
      (createChildParameter
        (IstarPackage.Literals.ACTOR__RELATION_FROM,
         IstarFactory.eINSTANCE.createRelation()));

    newChildDescriptors.add
      (createChildParameter
        (IstarPackage.Literals.ACTOR__RELATION_FROM,
         IstarFactory.eINSTANCE.createPartOfRelation()));

    newChildDescriptors.add
      (createChildParameter
        (IstarPackage.Literals.ACTOR__RELATION_FROM,
         IstarFactory.eINSTANCE.createPlaysRelation()));

    newChildDescriptors.add
      (createChildParameter
        (IstarPackage.Literals.ACTOR__RELATION_TO,
         IstarFactory.eINSTANCE.createRelation()));

    newChildDescriptors.add
      (createChildParameter
        (IstarPackage.Literals.ACTOR__RELATION_TO,
         IstarFactory.eINSTANCE.createPartOfRelation()));

    newChildDescriptors.add
      (createChildParameter
        (IstarPackage.Literals.ACTOR__RELATION_TO,
         IstarFactory.eINSTANCE.createPlaysRelation()));
  }

  /**
   * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getCreateChildText(Object owner, Object feature, Object child, Collection selection)
  {
    Object childFeature = feature;
    Object childObject = child;

    boolean qualify =
      childFeature == IstarPackage.Literals.ACTOR__RELATION_FROM ||
      childFeature == IstarPackage.Literals.ACTOR__RELATION_TO;

    if (qualify)
    {
      return getString
        ("_UI_CreateChild_text2",
         new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
    }
    return super.getCreateChildText(owner, feature, child, selection);
  }

  /**
   * Return the resource locator for this item provider's resources.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ResourceLocator getResourceLocator()
  {
    return IstarEditPlugin.INSTANCE;
  }

}
