/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package edu.toronto.cs.istar.provider;

import edu.toronto.cs.istar.util.IstarAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class IstarItemProviderAdapterFactory extends IstarAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable
{
  /**
   * This keeps track of the root adapter factory that delegates to this adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ComposedAdapterFactory parentAdapterFactory;

  /**
   * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IChangeNotifier changeNotifier = new ChangeNotifier();

  /**
   * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected Collection supportedTypes = new ArrayList();

  /**
   * This constructs an instance.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IstarItemProviderAdapterFactory()
  {
    supportedTypes.add(IEditingDomainItemProvider.class);
    supportedTypes.add(IStructuredItemContentProvider.class);
    supportedTypes.add(ITreeItemContentProvider.class);
    supportedTypes.add(IItemLabelProvider.class);
    supportedTypes.add(IItemPropertySource.class);		
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Actor} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ActorItemProvider actorItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Actor}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createActorAdapter()
  {
    if (actorItemProvider == null)
    {
      actorItemProvider = new ActorItemProvider(this);
    }

    return actorItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Agent} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AgentItemProvider agentItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Agent}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createAgentAdapter()
  {
    if (agentItemProvider == null)
    {
      agentItemProvider = new AgentItemProvider(this);
    }

    return agentItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.AndDecomposition} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AndDecompositionItemProvider andDecompositionItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.AndDecomposition}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createAndDecompositionAdapter()
  {
    if (andDecompositionItemProvider == null)
    {
      andDecompositionItemProvider = new AndDecompositionItemProvider(this);
    }

    return andDecompositionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.BreakContribution} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected BreakContributionItemProvider breakContributionItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.BreakContribution}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createBreakContributionAdapter()
  {
    if (breakContributionItemProvider == null)
    {
      breakContributionItemProvider = new BreakContributionItemProvider(this);
    }

    return breakContributionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Contribution} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ContributionItemProvider contributionItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Contribution}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createContributionAdapter()
  {
    if (contributionItemProvider == null)
    {
      contributionItemProvider = new ContributionItemProvider(this);
    }

    return contributionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Decomposition} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DecompositionItemProvider decompositionItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Decomposition}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createDecompositionAdapter()
  {
    if (decompositionItemProvider == null)
    {
      decompositionItemProvider = new DecompositionItemProvider(this);
    }

    return decompositionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Dependency} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DependencyItemProvider dependencyItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Dependency}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createDependencyAdapter()
  {
    if (dependencyItemProvider == null)
    {
      dependencyItemProvider = new DependencyItemProvider(this);
    }

    return dependencyItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Goal} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected GoalItemProvider goalItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Goal}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createGoalAdapter()
  {
    if (goalItemProvider == null)
    {
      goalItemProvider = new GoalItemProvider(this);
    }

    return goalItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.GoalDependency} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected GoalDependencyItemProvider goalDependencyItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.GoalDependency}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createGoalDependencyAdapter()
  {
    if (goalDependencyItemProvider == null)
    {
      goalDependencyItemProvider = new GoalDependencyItemProvider(this);
    }

    return goalDependencyItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.HelpContribution} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HelpContributionItemProvider helpContributionItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.HelpContribution}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createHelpContributionAdapter()
  {
    if (helpContributionItemProvider == null)
    {
      helpContributionItemProvider = new HelpContributionItemProvider(this);
    }

    return helpContributionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.HurtContribution} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected HurtContributionItemProvider hurtContributionItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.HurtContribution}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createHurtContributionAdapter()
  {
    if (hurtContributionItemProvider == null)
    {
      hurtContributionItemProvider = new HurtContributionItemProvider(this);
    }

    return hurtContributionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Intention} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IntentionItemProvider intentionItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Intention}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createIntentionAdapter()
  {
    if (intentionItemProvider == null)
    {
      intentionItemProvider = new IntentionItemProvider(this);
    }

    return intentionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Labeling} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LabelingItemProvider labelingItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Labeling}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createLabelingAdapter()
  {
    if (labelingItemProvider == null)
    {
      labelingItemProvider = new LabelingItemProvider(this);
    }

    return labelingItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.MakeContribution} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected MakeContributionItemProvider makeContributionItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.MakeContribution}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createMakeContributionAdapter()
  {
    if (makeContributionItemProvider == null)
    {
      makeContributionItemProvider = new MakeContributionItemProvider(this);
    }

    return makeContributionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Model} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ModelItemProvider modelItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Model}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createModelAdapter()
  {
    if (modelItemProvider == null)
    {
      modelItemProvider = new ModelItemProvider(this);
    }

    return modelItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.NoDecomposition} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected NoDecompositionItemProvider noDecompositionItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.NoDecomposition}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createNoDecompositionAdapter()
  {
    if (noDecompositionItemProvider == null)
    {
      noDecompositionItemProvider = new NoDecompositionItemProvider(this);
    }

    return noDecompositionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.OrAndDecomposition} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected OrAndDecompositionItemProvider orAndDecompositionItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.OrAndDecomposition}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createOrAndDecompositionAdapter()
  {
    if (orAndDecompositionItemProvider == null)
    {
      orAndDecompositionItemProvider = new OrAndDecompositionItemProvider(this);
    }

    return orAndDecompositionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.PartOfRelation} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PartOfRelationItemProvider partOfRelationItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.PartOfRelation}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createPartOfRelationAdapter()
  {
    if (partOfRelationItemProvider == null)
    {
      partOfRelationItemProvider = new PartOfRelationItemProvider(this);
    }

    return partOfRelationItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.PlaysRelation} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PlaysRelationItemProvider playsRelationItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.PlaysRelation}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createPlaysRelationAdapter()
  {
    if (playsRelationItemProvider == null)
    {
      playsRelationItemProvider = new PlaysRelationItemProvider(this);
    }

    return playsRelationItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Position} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PositionItemProvider positionItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Position}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createPositionAdapter()
  {
    if (positionItemProvider == null)
    {
      positionItemProvider = new PositionItemProvider(this);
    }

    return positionItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Property} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PropertyItemProvider propertyItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Property}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createPropertyAdapter()
  {
    if (propertyItemProvider == null)
    {
      propertyItemProvider = new PropertyItemProvider(this);
    }

    return propertyItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Relation} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RelationItemProvider relationItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Relation}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createRelationAdapter()
  {
    if (relationItemProvider == null)
    {
      relationItemProvider = new RelationItemProvider(this);
    }

    return relationItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Resource} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ResourceItemProvider resourceItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Resource}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createResourceAdapter()
  {
    if (resourceItemProvider == null)
    {
      resourceItemProvider = new ResourceItemProvider(this);
    }

    return resourceItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.ResourceDependency} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ResourceDependencyItemProvider resourceDependencyItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.ResourceDependency}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createResourceDependencyAdapter()
  {
    if (resourceDependencyItemProvider == null)
    {
      resourceDependencyItemProvider = new ResourceDependencyItemProvider(this);
    }

    return resourceDependencyItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Role} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected RoleItemProvider roleItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Role}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createRoleAdapter()
  {
    if (roleItemProvider == null)
    {
      roleItemProvider = new RoleItemProvider(this);
    }

    return roleItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.SoftGoalDependency} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SoftGoalDependencyItemProvider softGoalDependencyItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.SoftGoalDependency}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createSoftGoalDependencyAdapter()
  {
    if (softGoalDependencyItemProvider == null)
    {
      softGoalDependencyItemProvider = new SoftGoalDependencyItemProvider(this);
    }

    return softGoalDependencyItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Task} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TaskItemProvider taskItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Task}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTaskAdapter()
  {
    if (taskItemProvider == null)
    {
      taskItemProvider = new TaskItemProvider(this);
    }

    return taskItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.TaskDependency} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TaskDependencyItemProvider taskDependencyItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.TaskDependency}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTaskDependencyAdapter()
  {
    if (taskDependencyItemProvider == null)
    {
      taskDependencyItemProvider = new TaskDependencyItemProvider(this);
    }

    return taskDependencyItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.Topic} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TopicItemProvider topicItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.Topic}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createTopicAdapter()
  {
    if (topicItemProvider == null)
    {
      topicItemProvider = new TopicItemProvider(this);
    }

    return topicItemProvider;
  }

  /**
   * This keeps track of the one adapter used for all {@link edu.toronto.cs.istar.SoftGoal} instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SoftGoalItemProvider softGoalItemProvider;

  /**
   * This creates an adapter for a {@link edu.toronto.cs.istar.SoftGoal}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter createSoftGoalAdapter()
  {
    if (softGoalItemProvider == null)
    {
      softGoalItemProvider = new SoftGoalItemProvider(this);
    }

    return softGoalItemProvider;
  }

  /**
   * This returns the root adapter factory that contains this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComposeableAdapterFactory getRootAdapterFactory()
  {
    return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
  }

  /**
   * This sets the composed adapter factory that contains this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory)
  {
    this.parentAdapterFactory = parentAdapterFactory;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isFactoryForType(Object type)
  {
    return supportedTypes.contains(type) || super.isFactoryForType(type);
  }

  /**
   * This implementation substitutes the factory itself as the key for the adapter.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Adapter adapt(Notifier notifier, Object type)
  {
    return super.adapt(notifier, this);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object adapt(Object object, Object type)
  {
    if (isFactoryForType(type))
    {
      Object adapter = super.adapt(object, type);
      if (!(type instanceof Class) || (((Class)type).isInstance(adapter)))
      {
        return adapter;
      }
    }

    return null;
  }

  /**
   * This adds a listener.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void addListener(INotifyChangedListener notifyChangedListener)
  {
    changeNotifier.addListener(notifyChangedListener);
  }

  /**
   * This removes a listener.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void removeListener(INotifyChangedListener notifyChangedListener)
  {
    changeNotifier.removeListener(notifyChangedListener);
  }

  /**
   * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void fireNotifyChanged(Notification notification)
  {
    changeNotifier.fireNotifyChanged(notification);

    if (parentAdapterFactory != null)
    {
      parentAdapterFactory.fireNotifyChanged(notification);
    }
  }

  /**
   * This disposes all of the item providers created by this factory. 
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void dispose()
  {
    if (actorItemProvider != null) actorItemProvider.dispose();
    if (agentItemProvider != null) agentItemProvider.dispose();
    if (andDecompositionItemProvider != null) andDecompositionItemProvider.dispose();
    if (breakContributionItemProvider != null) breakContributionItemProvider.dispose();
    if (contributionItemProvider != null) contributionItemProvider.dispose();
    if (decompositionItemProvider != null) decompositionItemProvider.dispose();
    if (dependencyItemProvider != null) dependencyItemProvider.dispose();
    if (goalItemProvider != null) goalItemProvider.dispose();
    if (goalDependencyItemProvider != null) goalDependencyItemProvider.dispose();
    if (helpContributionItemProvider != null) helpContributionItemProvider.dispose();
    if (hurtContributionItemProvider != null) hurtContributionItemProvider.dispose();
    if (intentionItemProvider != null) intentionItemProvider.dispose();
    if (labelingItemProvider != null) labelingItemProvider.dispose();
    if (makeContributionItemProvider != null) makeContributionItemProvider.dispose();
    if (modelItemProvider != null) modelItemProvider.dispose();
    if (noDecompositionItemProvider != null) noDecompositionItemProvider.dispose();
    if (orAndDecompositionItemProvider != null) orAndDecompositionItemProvider.dispose();
    if (partOfRelationItemProvider != null) partOfRelationItemProvider.dispose();
    if (playsRelationItemProvider != null) playsRelationItemProvider.dispose();
    if (positionItemProvider != null) positionItemProvider.dispose();
    if (propertyItemProvider != null) propertyItemProvider.dispose();
    if (relationItemProvider != null) relationItemProvider.dispose();
    if (resourceItemProvider != null) resourceItemProvider.dispose();
    if (resourceDependencyItemProvider != null) resourceDependencyItemProvider.dispose();
    if (roleItemProvider != null) roleItemProvider.dispose();
    if (softGoalDependencyItemProvider != null) softGoalDependencyItemProvider.dispose();
    if (taskItemProvider != null) taskItemProvider.dispose();
    if (taskDependencyItemProvider != null) taskDependencyItemProvider.dispose();
    if (topicItemProvider != null) topicItemProvider.dispose();
    if (softGoalItemProvider != null) softGoalItemProvider.dispose();
  }

}
