/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package edu.toronto.cs.istar;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see edu.toronto.cs.istar.IstarFactory
 * @model kind="package"
 * @generated
 */
public interface IstarPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "istar";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http:///edu/toronto/cs/istar.ecore";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "edu.toronto.cs.istar";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  IstarPackage eINSTANCE = edu.toronto.cs.istar.impl.IstarPackageImpl.init();

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.ActorImpl <em>Actor</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.ActorImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getActor()
   * @generated
   */
  int ACTOR = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ACTOR__NAME = 0;

  /**
   * The feature id for the '<em><b>Intentions</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ACTOR__INTENTIONS = 1;

  /**
   * The feature id for the '<em><b>Relation From</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ACTOR__RELATION_FROM = 2;

  /**
   * The feature id for the '<em><b>Relation To</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ACTOR__RELATION_TO = 3;

  /**
   * The feature id for the '<em><b>All Intentions</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ACTOR__ALL_INTENTIONS = 4;

  /**
   * The number of structural features of the '<em>Actor</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ACTOR_FEATURE_COUNT = 5;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.AgentImpl <em>Agent</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.AgentImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getAgent()
   * @generated
   */
  int AGENT = 1;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AGENT__NAME = ACTOR__NAME;

  /**
   * The feature id for the '<em><b>Intentions</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AGENT__INTENTIONS = ACTOR__INTENTIONS;

  /**
   * The feature id for the '<em><b>Relation From</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AGENT__RELATION_FROM = ACTOR__RELATION_FROM;

  /**
   * The feature id for the '<em><b>Relation To</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AGENT__RELATION_TO = ACTOR__RELATION_TO;

  /**
   * The feature id for the '<em><b>All Intentions</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AGENT__ALL_INTENTIONS = ACTOR__ALL_INTENTIONS;

  /**
   * The number of structural features of the '<em>Agent</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AGENT_FEATURE_COUNT = ACTOR_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.DecompositionImpl <em>Decomposition</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.DecompositionImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getDecomposition()
   * @generated
   */
  int DECOMPOSITION = 5;

  /**
   * The number of structural features of the '<em>Decomposition</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DECOMPOSITION_FEATURE_COUNT = 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.AndDecompositionImpl <em>And Decomposition</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.AndDecompositionImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getAndDecomposition()
   * @generated
   */
  int AND_DECOMPOSITION = 2;

  /**
   * The number of structural features of the '<em>And Decomposition</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int AND_DECOMPOSITION_FEATURE_COUNT = DECOMPOSITION_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.ContributionImpl <em>Contribution</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.ContributionImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getContribution()
   * @generated
   */
  int CONTRIBUTION = 4;

  /**
   * The feature id for the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTRIBUTION__TARGET = 0;

  /**
   * The number of structural features of the '<em>Contribution</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTRIBUTION_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.BreakContributionImpl <em>Break Contribution</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.BreakContributionImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getBreakContribution()
   * @generated
   */
  int BREAK_CONTRIBUTION = 3;

  /**
   * The feature id for the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BREAK_CONTRIBUTION__TARGET = CONTRIBUTION__TARGET;

  /**
   * The number of structural features of the '<em>Break Contribution</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BREAK_CONTRIBUTION_FEATURE_COUNT = CONTRIBUTION_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.DependencyImpl <em>Dependency</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.DependencyImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getDependency()
   * @generated
   */
  int DEPENDENCY = 6;

  /**
   * The feature id for the '<em><b>Intention From</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPENDENCY__INTENTION_FROM = 0;

  /**
   * The feature id for the '<em><b>Intention To</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPENDENCY__INTENTION_TO = 1;

  /**
   * The feature id for the '<em><b>Trust</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPENDENCY__TRUST = 2;

  /**
   * The number of structural features of the '<em>Dependency</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DEPENDENCY_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.IntentionImpl <em>Intention</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.IntentionImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getIntention()
   * @generated
   */
  int INTENTION = 11;

  /**
   * The feature id for the '<em><b>Root</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION__ROOT = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION__NAME = 1;

  /**
   * The feature id for the '<em><b>Property</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION__PROPERTY = 2;

  /**
   * The feature id for the '<em><b>Actor</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION__ACTOR = 3;

  /**
   * The feature id for the '<em><b>Decomposition Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION__DECOMPOSITION_TYPE = 4;

  /**
   * The feature id for the '<em><b>Parent</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION__PARENT = 5;

  /**
   * The feature id for the '<em><b>Children</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION__CHILDREN = 6;

  /**
   * The feature id for the '<em><b>Contributions</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION__CONTRIBUTIONS = 7;

  /**
   * The feature id for the '<em><b>Dependency From</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION__DEPENDENCY_FROM = 8;

  /**
   * The feature id for the '<em><b>Dependency To</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION__DEPENDENCY_TO = 9;

  /**
   * The feature id for the '<em><b>Topic</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION__TOPIC = 10;

  /**
   * The feature id for the '<em><b>Input</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION__INPUT = 11;

  /**
   * The feature id for the '<em><b>Output</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION__OUTPUT = 12;

  /**
   * The number of structural features of the '<em>Intention</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INTENTION_FEATURE_COUNT = 13;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.GoalImpl <em>Goal</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.GoalImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getGoal()
   * @generated
   */
  int GOAL = 7;

  /**
   * The feature id for the '<em><b>Root</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__ROOT = INTENTION__ROOT;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__NAME = INTENTION__NAME;

  /**
   * The feature id for the '<em><b>Property</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__PROPERTY = INTENTION__PROPERTY;

  /**
   * The feature id for the '<em><b>Actor</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__ACTOR = INTENTION__ACTOR;

  /**
   * The feature id for the '<em><b>Decomposition Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__DECOMPOSITION_TYPE = INTENTION__DECOMPOSITION_TYPE;

  /**
   * The feature id for the '<em><b>Parent</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__PARENT = INTENTION__PARENT;

  /**
   * The feature id for the '<em><b>Children</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__CHILDREN = INTENTION__CHILDREN;

  /**
   * The feature id for the '<em><b>Contributions</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__CONTRIBUTIONS = INTENTION__CONTRIBUTIONS;

  /**
   * The feature id for the '<em><b>Dependency From</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__DEPENDENCY_FROM = INTENTION__DEPENDENCY_FROM;

  /**
   * The feature id for the '<em><b>Dependency To</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__DEPENDENCY_TO = INTENTION__DEPENDENCY_TO;

  /**
   * The feature id for the '<em><b>Topic</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__TOPIC = INTENTION__TOPIC;

  /**
   * The feature id for the '<em><b>Input</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__INPUT = INTENTION__INPUT;

  /**
   * The feature id for the '<em><b>Output</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__OUTPUT = INTENTION__OUTPUT;

  /**
   * The feature id for the '<em><b>Label</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL__LABEL = INTENTION_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Goal</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL_FEATURE_COUNT = INTENTION_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.GoalDependencyImpl <em>Goal Dependency</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.GoalDependencyImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getGoalDependency()
   * @generated
   */
  int GOAL_DEPENDENCY = 8;

  /**
   * The feature id for the '<em><b>Intention From</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL_DEPENDENCY__INTENTION_FROM = DEPENDENCY__INTENTION_FROM;

  /**
   * The feature id for the '<em><b>Intention To</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL_DEPENDENCY__INTENTION_TO = DEPENDENCY__INTENTION_TO;

  /**
   * The feature id for the '<em><b>Trust</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL_DEPENDENCY__TRUST = DEPENDENCY__TRUST;

  /**
   * The number of structural features of the '<em>Goal Dependency</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int GOAL_DEPENDENCY_FEATURE_COUNT = DEPENDENCY_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.HelpContributionImpl <em>Help Contribution</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.HelpContributionImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getHelpContribution()
   * @generated
   */
  int HELP_CONTRIBUTION = 9;

  /**
   * The feature id for the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HELP_CONTRIBUTION__TARGET = CONTRIBUTION__TARGET;

  /**
   * The number of structural features of the '<em>Help Contribution</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HELP_CONTRIBUTION_FEATURE_COUNT = CONTRIBUTION_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.HurtContributionImpl <em>Hurt Contribution</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.HurtContributionImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getHurtContribution()
   * @generated
   */
  int HURT_CONTRIBUTION = 10;

  /**
   * The feature id for the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HURT_CONTRIBUTION__TARGET = CONTRIBUTION__TARGET;

  /**
   * The number of structural features of the '<em>Hurt Contribution</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int HURT_CONTRIBUTION_FEATURE_COUNT = CONTRIBUTION_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.LabelingImpl <em>Labeling</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.LabelingImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getLabeling()
   * @generated
   */
  int LABELING = 12;

  /**
   * The feature id for the '<em><b>Label</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LABELING__LABEL = 0;

  /**
   * The number of structural features of the '<em>Labeling</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LABELING_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.MakeContributionImpl <em>Make Contribution</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.MakeContributionImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getMakeContribution()
   * @generated
   */
  int MAKE_CONTRIBUTION = 13;

  /**
   * The feature id for the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAKE_CONTRIBUTION__TARGET = CONTRIBUTION__TARGET;

  /**
   * The number of structural features of the '<em>Make Contribution</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MAKE_CONTRIBUTION_FEATURE_COUNT = CONTRIBUTION_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.ModelImpl <em>Model</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.ModelImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getModel()
   * @generated
   */
  int MODEL = 14;

  /**
   * The feature id for the '<em><b>Actors</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL__ACTORS = 0;

  /**
   * The number of structural features of the '<em>Model</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int MODEL_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.NoDecompositionImpl <em>No Decomposition</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.NoDecompositionImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getNoDecomposition()
   * @generated
   */
  int NO_DECOMPOSITION = 15;

  /**
   * The number of structural features of the '<em>No Decomposition</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int NO_DECOMPOSITION_FEATURE_COUNT = DECOMPOSITION_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.OrAndDecompositionImpl <em>Or And Decomposition</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.OrAndDecompositionImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getOrAndDecomposition()
   * @generated
   */
  int OR_AND_DECOMPOSITION = 16;

  /**
   * The number of structural features of the '<em>Or And Decomposition</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int OR_AND_DECOMPOSITION_FEATURE_COUNT = DECOMPOSITION_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.RelationImpl <em>Relation</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.RelationImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getRelation()
   * @generated
   */
  int RELATION = 21;

  /**
   * The feature id for the '<em><b>Actor From</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RELATION__ACTOR_FROM = 0;

  /**
   * The feature id for the '<em><b>Actor To</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RELATION__ACTOR_TO = 1;

  /**
   * The number of structural features of the '<em>Relation</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RELATION_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.PartOfRelationImpl <em>Part Of Relation</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.PartOfRelationImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getPartOfRelation()
   * @generated
   */
  int PART_OF_RELATION = 17;

  /**
   * The feature id for the '<em><b>Actor From</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PART_OF_RELATION__ACTOR_FROM = RELATION__ACTOR_FROM;

  /**
   * The feature id for the '<em><b>Actor To</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PART_OF_RELATION__ACTOR_TO = RELATION__ACTOR_TO;

  /**
   * The number of structural features of the '<em>Part Of Relation</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PART_OF_RELATION_FEATURE_COUNT = RELATION_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.PlaysRelationImpl <em>Plays Relation</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.PlaysRelationImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getPlaysRelation()
   * @generated
   */
  int PLAYS_RELATION = 18;

  /**
   * The feature id for the '<em><b>Actor From</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLAYS_RELATION__ACTOR_FROM = RELATION__ACTOR_FROM;

  /**
   * The feature id for the '<em><b>Actor To</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLAYS_RELATION__ACTOR_TO = RELATION__ACTOR_TO;

  /**
   * The number of structural features of the '<em>Plays Relation</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLAYS_RELATION_FEATURE_COUNT = RELATION_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.PositionImpl <em>Position</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.PositionImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getPosition()
   * @generated
   */
  int POSITION = 19;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int POSITION__NAME = ACTOR__NAME;

  /**
   * The feature id for the '<em><b>Intentions</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int POSITION__INTENTIONS = ACTOR__INTENTIONS;

  /**
   * The feature id for the '<em><b>Relation From</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int POSITION__RELATION_FROM = ACTOR__RELATION_FROM;

  /**
   * The feature id for the '<em><b>Relation To</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int POSITION__RELATION_TO = ACTOR__RELATION_TO;

  /**
   * The feature id for the '<em><b>All Intentions</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int POSITION__ALL_INTENTIONS = ACTOR__ALL_INTENTIONS;

  /**
   * The number of structural features of the '<em>Position</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int POSITION_FEATURE_COUNT = ACTOR_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.PropertyImpl <em>Property</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.PropertyImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getProperty()
   * @generated
   */
  int PROPERTY = 20;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY__NAME = 0;

  /**
   * The feature id for the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY__VALUE = 1;

  /**
   * The number of structural features of the '<em>Property</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROPERTY_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.ResourceImpl <em>Resource</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.ResourceImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getResource()
   * @generated
   */
  int RESOURCE = 22;

  /**
   * The feature id for the '<em><b>Root</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__ROOT = INTENTION__ROOT;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__NAME = INTENTION__NAME;

  /**
   * The feature id for the '<em><b>Property</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__PROPERTY = INTENTION__PROPERTY;

  /**
   * The feature id for the '<em><b>Actor</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__ACTOR = INTENTION__ACTOR;

  /**
   * The feature id for the '<em><b>Decomposition Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__DECOMPOSITION_TYPE = INTENTION__DECOMPOSITION_TYPE;

  /**
   * The feature id for the '<em><b>Parent</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__PARENT = INTENTION__PARENT;

  /**
   * The feature id for the '<em><b>Children</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__CHILDREN = INTENTION__CHILDREN;

  /**
   * The feature id for the '<em><b>Contributions</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__CONTRIBUTIONS = INTENTION__CONTRIBUTIONS;

  /**
   * The feature id for the '<em><b>Dependency From</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__DEPENDENCY_FROM = INTENTION__DEPENDENCY_FROM;

  /**
   * The feature id for the '<em><b>Dependency To</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__DEPENDENCY_TO = INTENTION__DEPENDENCY_TO;

  /**
   * The feature id for the '<em><b>Topic</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__TOPIC = INTENTION__TOPIC;

  /**
   * The feature id for the '<em><b>Input</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__INPUT = INTENTION__INPUT;

  /**
   * The feature id for the '<em><b>Output</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE__OUTPUT = INTENTION__OUTPUT;

  /**
   * The number of structural features of the '<em>Resource</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE_FEATURE_COUNT = INTENTION_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.ResourceDependencyImpl <em>Resource Dependency</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.ResourceDependencyImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getResourceDependency()
   * @generated
   */
  int RESOURCE_DEPENDENCY = 23;

  /**
   * The feature id for the '<em><b>Intention From</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE_DEPENDENCY__INTENTION_FROM = DEPENDENCY__INTENTION_FROM;

  /**
   * The feature id for the '<em><b>Intention To</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE_DEPENDENCY__INTENTION_TO = DEPENDENCY__INTENTION_TO;

  /**
   * The feature id for the '<em><b>Trust</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE_DEPENDENCY__TRUST = DEPENDENCY__TRUST;

  /**
   * The number of structural features of the '<em>Resource Dependency</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int RESOURCE_DEPENDENCY_FEATURE_COUNT = DEPENDENCY_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.RoleImpl <em>Role</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.RoleImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getRole()
   * @generated
   */
  int ROLE = 24;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__NAME = ACTOR__NAME;

  /**
   * The feature id for the '<em><b>Intentions</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__INTENTIONS = ACTOR__INTENTIONS;

  /**
   * The feature id for the '<em><b>Relation From</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__RELATION_FROM = ACTOR__RELATION_FROM;

  /**
   * The feature id for the '<em><b>Relation To</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__RELATION_TO = ACTOR__RELATION_TO;

  /**
   * The feature id for the '<em><b>All Intentions</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE__ALL_INTENTIONS = ACTOR__ALL_INTENTIONS;

  /**
   * The number of structural features of the '<em>Role</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int ROLE_FEATURE_COUNT = ACTOR_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.SoftGoalDependencyImpl <em>Soft Goal Dependency</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.SoftGoalDependencyImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getSoftGoalDependency()
   * @generated
   */
  int SOFT_GOAL_DEPENDENCY = 25;

  /**
   * The feature id for the '<em><b>Intention From</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL_DEPENDENCY__INTENTION_FROM = DEPENDENCY__INTENTION_FROM;

  /**
   * The feature id for the '<em><b>Intention To</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL_DEPENDENCY__INTENTION_TO = DEPENDENCY__INTENTION_TO;

  /**
   * The feature id for the '<em><b>Trust</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL_DEPENDENCY__TRUST = DEPENDENCY__TRUST;

  /**
   * The number of structural features of the '<em>Soft Goal Dependency</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL_DEPENDENCY_FEATURE_COUNT = DEPENDENCY_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.TaskImpl <em>Task</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.TaskImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getTask()
   * @generated
   */
  int TASK = 26;

  /**
   * The feature id for the '<em><b>Root</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__ROOT = INTENTION__ROOT;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__NAME = INTENTION__NAME;

  /**
   * The feature id for the '<em><b>Property</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__PROPERTY = INTENTION__PROPERTY;

  /**
   * The feature id for the '<em><b>Actor</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__ACTOR = INTENTION__ACTOR;

  /**
   * The feature id for the '<em><b>Decomposition Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__DECOMPOSITION_TYPE = INTENTION__DECOMPOSITION_TYPE;

  /**
   * The feature id for the '<em><b>Parent</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__PARENT = INTENTION__PARENT;

  /**
   * The feature id for the '<em><b>Children</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__CHILDREN = INTENTION__CHILDREN;

  /**
   * The feature id for the '<em><b>Contributions</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__CONTRIBUTIONS = INTENTION__CONTRIBUTIONS;

  /**
   * The feature id for the '<em><b>Dependency From</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__DEPENDENCY_FROM = INTENTION__DEPENDENCY_FROM;

  /**
   * The feature id for the '<em><b>Dependency To</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__DEPENDENCY_TO = INTENTION__DEPENDENCY_TO;

  /**
   * The feature id for the '<em><b>Topic</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__TOPIC = INTENTION__TOPIC;

  /**
   * The feature id for the '<em><b>Input</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__INPUT = INTENTION__INPUT;

  /**
   * The feature id for the '<em><b>Output</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK__OUTPUT = INTENTION__OUTPUT;

  /**
   * The number of structural features of the '<em>Task</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK_FEATURE_COUNT = INTENTION_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.TaskDependencyImpl <em>Task Dependency</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.TaskDependencyImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getTaskDependency()
   * @generated
   */
  int TASK_DEPENDENCY = 27;

  /**
   * The feature id for the '<em><b>Intention From</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK_DEPENDENCY__INTENTION_FROM = DEPENDENCY__INTENTION_FROM;

  /**
   * The feature id for the '<em><b>Intention To</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK_DEPENDENCY__INTENTION_TO = DEPENDENCY__INTENTION_TO;

  /**
   * The feature id for the '<em><b>Trust</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK_DEPENDENCY__TRUST = DEPENDENCY__TRUST;

  /**
   * The number of structural features of the '<em>Task Dependency</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TASK_DEPENDENCY_FEATURE_COUNT = DEPENDENCY_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.TopicImpl <em>Topic</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.TopicImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getTopic()
   * @generated
   */
  int TOPIC = 28;

  /**
   * The feature id for the '<em><b>Topic</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TOPIC__TOPIC = 0;

  /**
   * The feature id for the '<em><b>Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TOPIC__TYPE = 1;

  /**
   * The number of structural features of the '<em>Topic</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TOPIC_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.impl.SoftGoalImpl <em>Soft Goal</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.impl.SoftGoalImpl
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getSoftGoal()
   * @generated
   */
  int SOFT_GOAL = 29;

  /**
   * The feature id for the '<em><b>Root</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__ROOT = INTENTION__ROOT;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__NAME = INTENTION__NAME;

  /**
   * The feature id for the '<em><b>Property</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__PROPERTY = INTENTION__PROPERTY;

  /**
   * The feature id for the '<em><b>Actor</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__ACTOR = INTENTION__ACTOR;

  /**
   * The feature id for the '<em><b>Decomposition Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__DECOMPOSITION_TYPE = INTENTION__DECOMPOSITION_TYPE;

  /**
   * The feature id for the '<em><b>Parent</b></em>' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__PARENT = INTENTION__PARENT;

  /**
   * The feature id for the '<em><b>Children</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__CHILDREN = INTENTION__CHILDREN;

  /**
   * The feature id for the '<em><b>Contributions</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__CONTRIBUTIONS = INTENTION__CONTRIBUTIONS;

  /**
   * The feature id for the '<em><b>Dependency From</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__DEPENDENCY_FROM = INTENTION__DEPENDENCY_FROM;

  /**
   * The feature id for the '<em><b>Dependency To</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__DEPENDENCY_TO = INTENTION__DEPENDENCY_TO;

  /**
   * The feature id for the '<em><b>Topic</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__TOPIC = INTENTION__TOPIC;

  /**
   * The feature id for the '<em><b>Input</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__INPUT = INTENTION__INPUT;

  /**
   * The feature id for the '<em><b>Output</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__OUTPUT = INTENTION__OUTPUT;

  /**
   * The feature id for the '<em><b>Label</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL__LABEL = INTENTION_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>Soft Goal</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int SOFT_GOAL_FEATURE_COUNT = INTENTION_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.ConflictSoftLabel <em>Conflict Soft Label</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.ConflictSoftLabel
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getConflictSoftLabel()
   * @generated
   */
  int CONFLICT_SOFT_LABEL = 30;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.DeniedHardLabel <em>Denied Hard Label</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.DeniedHardLabel
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getDeniedHardLabel()
   * @generated
   */
  int DENIED_HARD_LABEL = 31;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.DeniedSoftLabel <em>Denied Soft Label</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.DeniedSoftLabel
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getDeniedSoftLabel()
   * @generated
   */
  int DENIED_SOFT_LABEL = 32;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.HardLabel <em>Hard Label</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.HardLabel
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getHardLabel()
   * @generated
   */
  int HARD_LABEL = 33;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.Label <em>Label</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.Label
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getLabel()
   * @generated
   */
  int LABEL = 34;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.PartiallyDeniedSoftLabel <em>Partially Denied Soft Label</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.PartiallyDeniedSoftLabel
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getPartiallyDeniedSoftLabel()
   * @generated
   */
  int PARTIALLY_DENIED_SOFT_LABEL = 35;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.PartiallySatisficedSoftLabel <em>Partially Satisficed Soft Label</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.PartiallySatisficedSoftLabel
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getPartiallySatisficedSoftLabel()
   * @generated
   */
  int PARTIALLY_SATISFICED_SOFT_LABEL = 36;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.SatisficedSoftLabel <em>Satisficed Soft Label</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.SatisficedSoftLabel
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getSatisficedSoftLabel()
   * @generated
   */
  int SATISFICED_SOFT_LABEL = 37;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.SatisfiedHardLabel <em>Satisfied Hard Label</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.SatisfiedHardLabel
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getSatisfiedHardLabel()
   * @generated
   */
  int SATISFIED_HARD_LABEL = 38;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.SoftLabel <em>Soft Label</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.SoftLabel
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getSoftLabel()
   * @generated
   */
  int SOFT_LABEL = 39;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.UnknownHardLabel <em>Unknown Hard Label</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.UnknownHardLabel
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getUnknownHardLabel()
   * @generated
   */
  int UNKNOWN_HARD_LABEL = 40;

  /**
   * The meta object id for the '{@link edu.toronto.cs.istar.UnknownSoftLabel <em>Unknown Soft Label</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see edu.toronto.cs.istar.UnknownSoftLabel
   * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getUnknownSoftLabel()
   * @generated
   */
  int UNKNOWN_SOFT_LABEL = 41;


  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Actor <em>Actor</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Actor</em>'.
   * @see edu.toronto.cs.istar.Actor
   * @generated
   */
  EClass getActor();

  /**
   * Returns the meta object for the attribute '{@link edu.toronto.cs.istar.Actor#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see edu.toronto.cs.istar.Actor#getName()
   * @see #getActor()
   * @generated
   */
  EAttribute getActor_Name();

  /**
   * Returns the meta object for the containment reference list '{@link edu.toronto.cs.istar.Actor#getIntentions <em>Intentions</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Intentions</em>'.
   * @see edu.toronto.cs.istar.Actor#getIntentions()
   * @see #getActor()
   * @generated
   */
  EReference getActor_Intentions();

  /**
   * Returns the meta object for the containment reference list '{@link edu.toronto.cs.istar.Actor#getRelationFrom <em>Relation From</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Relation From</em>'.
   * @see edu.toronto.cs.istar.Actor#getRelationFrom()
   * @see #getActor()
   * @generated
   */
  EReference getActor_RelationFrom();

  /**
   * Returns the meta object for the containment reference list '{@link edu.toronto.cs.istar.Actor#getRelationTo <em>Relation To</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Relation To</em>'.
   * @see edu.toronto.cs.istar.Actor#getRelationTo()
   * @see #getActor()
   * @generated
   */
  EReference getActor_RelationTo();

  /**
   * Returns the meta object for the reference list '{@link edu.toronto.cs.istar.Actor#getAllIntentions <em>All Intentions</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>All Intentions</em>'.
   * @see edu.toronto.cs.istar.Actor#getAllIntentions()
   * @see #getActor()
   * @generated
   */
  EReference getActor_AllIntentions();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Agent <em>Agent</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Agent</em>'.
   * @see edu.toronto.cs.istar.Agent
   * @generated
   */
  EClass getAgent();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.AndDecomposition <em>And Decomposition</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>And Decomposition</em>'.
   * @see edu.toronto.cs.istar.AndDecomposition
   * @generated
   */
  EClass getAndDecomposition();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.BreakContribution <em>Break Contribution</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Break Contribution</em>'.
   * @see edu.toronto.cs.istar.BreakContribution
   * @generated
   */
  EClass getBreakContribution();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Contribution <em>Contribution</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Contribution</em>'.
   * @see edu.toronto.cs.istar.Contribution
   * @generated
   */
  EClass getContribution();

  /**
   * Returns the meta object for the reference '{@link edu.toronto.cs.istar.Contribution#getTarget <em>Target</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Target</em>'.
   * @see edu.toronto.cs.istar.Contribution#getTarget()
   * @see #getContribution()
   * @generated
   */
  EReference getContribution_Target();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Decomposition <em>Decomposition</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Decomposition</em>'.
   * @see edu.toronto.cs.istar.Decomposition
   * @generated
   */
  EClass getDecomposition();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Dependency <em>Dependency</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Dependency</em>'.
   * @see edu.toronto.cs.istar.Dependency
   * @generated
   */
  EClass getDependency();

  /**
   * Returns the meta object for the reference '{@link edu.toronto.cs.istar.Dependency#getIntentionFrom <em>Intention From</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Intention From</em>'.
   * @see edu.toronto.cs.istar.Dependency#getIntentionFrom()
   * @see #getDependency()
   * @generated
   */
  EReference getDependency_IntentionFrom();

  /**
   * Returns the meta object for the reference '{@link edu.toronto.cs.istar.Dependency#getIntentionTo <em>Intention To</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Intention To</em>'.
   * @see edu.toronto.cs.istar.Dependency#getIntentionTo()
   * @see #getDependency()
   * @generated
   */
  EReference getDependency_IntentionTo();

  /**
   * Returns the meta object for the attribute '{@link edu.toronto.cs.istar.Dependency#getTrust <em>Trust</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Trust</em>'.
   * @see edu.toronto.cs.istar.Dependency#getTrust()
   * @see #getDependency()
   * @generated
   */
  EAttribute getDependency_Trust();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Goal <em>Goal</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Goal</em>'.
   * @see edu.toronto.cs.istar.Goal
   * @generated
   */
  EClass getGoal();

  /**
   * Returns the meta object for the attribute '{@link edu.toronto.cs.istar.Goal#getLabel <em>Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Label</em>'.
   * @see edu.toronto.cs.istar.Goal#getLabel()
   * @see #getGoal()
   * @generated
   */
  EAttribute getGoal_Label();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.GoalDependency <em>Goal Dependency</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Goal Dependency</em>'.
   * @see edu.toronto.cs.istar.GoalDependency
   * @generated
   */
  EClass getGoalDependency();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.HelpContribution <em>Help Contribution</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Help Contribution</em>'.
   * @see edu.toronto.cs.istar.HelpContribution
   * @generated
   */
  EClass getHelpContribution();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.HurtContribution <em>Hurt Contribution</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Hurt Contribution</em>'.
   * @see edu.toronto.cs.istar.HurtContribution
   * @generated
   */
  EClass getHurtContribution();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Intention <em>Intention</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Intention</em>'.
   * @see edu.toronto.cs.istar.Intention
   * @generated
   */
  EClass getIntention();

  /**
   * Returns the meta object for the reference '{@link edu.toronto.cs.istar.Intention#getRoot <em>Root</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Root</em>'.
   * @see edu.toronto.cs.istar.Intention#getRoot()
   * @see #getIntention()
   * @generated
   */
  EReference getIntention_Root();

  /**
   * Returns the meta object for the attribute '{@link edu.toronto.cs.istar.Intention#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see edu.toronto.cs.istar.Intention#getName()
   * @see #getIntention()
   * @generated
   */
  EAttribute getIntention_Name();

  /**
   * Returns the meta object for the containment reference list '{@link edu.toronto.cs.istar.Intention#getProperty <em>Property</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Property</em>'.
   * @see edu.toronto.cs.istar.Intention#getProperty()
   * @see #getIntention()
   * @generated
   */
  EReference getIntention_Property();

  /**
   * Returns the meta object for the container reference '{@link edu.toronto.cs.istar.Intention#getActor <em>Actor</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Actor</em>'.
   * @see edu.toronto.cs.istar.Intention#getActor()
   * @see #getIntention()
   * @generated
   */
  EReference getIntention_Actor();

  /**
   * Returns the meta object for the reference '{@link edu.toronto.cs.istar.Intention#getDecompositionType <em>Decomposition Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Decomposition Type</em>'.
   * @see edu.toronto.cs.istar.Intention#getDecompositionType()
   * @see #getIntention()
   * @generated
   */
  EReference getIntention_DecompositionType();

  /**
   * Returns the meta object for the container reference '{@link edu.toronto.cs.istar.Intention#getParent <em>Parent</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Parent</em>'.
   * @see edu.toronto.cs.istar.Intention#getParent()
   * @see #getIntention()
   * @generated
   */
  EReference getIntention_Parent();

  /**
   * Returns the meta object for the containment reference list '{@link edu.toronto.cs.istar.Intention#getChildren <em>Children</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Children</em>'.
   * @see edu.toronto.cs.istar.Intention#getChildren()
   * @see #getIntention()
   * @generated
   */
  EReference getIntention_Children();

  /**
   * Returns the meta object for the containment reference list '{@link edu.toronto.cs.istar.Intention#getContributions <em>Contributions</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Contributions</em>'.
   * @see edu.toronto.cs.istar.Intention#getContributions()
   * @see #getIntention()
   * @generated
   */
  EReference getIntention_Contributions();

  /**
   * Returns the meta object for the reference list '{@link edu.toronto.cs.istar.Intention#getDependencyFrom <em>Dependency From</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Dependency From</em>'.
   * @see edu.toronto.cs.istar.Intention#getDependencyFrom()
   * @see #getIntention()
   * @generated
   */
  EReference getIntention_DependencyFrom();

  /**
   * Returns the meta object for the reference list '{@link edu.toronto.cs.istar.Intention#getDependencyTo <em>Dependency To</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Dependency To</em>'.
   * @see edu.toronto.cs.istar.Intention#getDependencyTo()
   * @see #getIntention()
   * @generated
   */
  EReference getIntention_DependencyTo();

  /**
   * Returns the meta object for the containment reference list '{@link edu.toronto.cs.istar.Intention#getTopic <em>Topic</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Topic</em>'.
   * @see edu.toronto.cs.istar.Intention#getTopic()
   * @see #getIntention()
   * @generated
   */
  EReference getIntention_Topic();

  /**
   * Returns the meta object for the containment reference list '{@link edu.toronto.cs.istar.Intention#getInput <em>Input</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Input</em>'.
   * @see edu.toronto.cs.istar.Intention#getInput()
   * @see #getIntention()
   * @generated
   */
  EReference getIntention_Input();

  /**
   * Returns the meta object for the containment reference list '{@link edu.toronto.cs.istar.Intention#getOutput <em>Output</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Output</em>'.
   * @see edu.toronto.cs.istar.Intention#getOutput()
   * @see #getIntention()
   * @generated
   */
  EReference getIntention_Output();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Labeling <em>Labeling</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Labeling</em>'.
   * @see edu.toronto.cs.istar.Labeling
   * @generated
   */
  EClass getLabeling();

  /**
   * Returns the meta object for the attribute '{@link edu.toronto.cs.istar.Labeling#getLabel <em>Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Label</em>'.
   * @see edu.toronto.cs.istar.Labeling#getLabel()
   * @see #getLabeling()
   * @generated
   */
  EAttribute getLabeling_Label();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.MakeContribution <em>Make Contribution</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Make Contribution</em>'.
   * @see edu.toronto.cs.istar.MakeContribution
   * @generated
   */
  EClass getMakeContribution();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Model <em>Model</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Model</em>'.
   * @see edu.toronto.cs.istar.Model
   * @generated
   */
  EClass getModel();

  /**
   * Returns the meta object for the containment reference list '{@link edu.toronto.cs.istar.Model#getActors <em>Actors</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Actors</em>'.
   * @see edu.toronto.cs.istar.Model#getActors()
   * @see #getModel()
   * @generated
   */
  EReference getModel_Actors();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.NoDecomposition <em>No Decomposition</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>No Decomposition</em>'.
   * @see edu.toronto.cs.istar.NoDecomposition
   * @generated
   */
  EClass getNoDecomposition();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.OrAndDecomposition <em>Or And Decomposition</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Or And Decomposition</em>'.
   * @see edu.toronto.cs.istar.OrAndDecomposition
   * @generated
   */
  EClass getOrAndDecomposition();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.PartOfRelation <em>Part Of Relation</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Part Of Relation</em>'.
   * @see edu.toronto.cs.istar.PartOfRelation
   * @generated
   */
  EClass getPartOfRelation();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.PlaysRelation <em>Plays Relation</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Plays Relation</em>'.
   * @see edu.toronto.cs.istar.PlaysRelation
   * @generated
   */
  EClass getPlaysRelation();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Position <em>Position</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Position</em>'.
   * @see edu.toronto.cs.istar.Position
   * @generated
   */
  EClass getPosition();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Property <em>Property</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Property</em>'.
   * @see edu.toronto.cs.istar.Property
   * @generated
   */
  EClass getProperty();

  /**
   * Returns the meta object for the attribute '{@link edu.toronto.cs.istar.Property#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see edu.toronto.cs.istar.Property#getName()
   * @see #getProperty()
   * @generated
   */
  EAttribute getProperty_Name();

  /**
   * Returns the meta object for the attribute '{@link edu.toronto.cs.istar.Property#getValue <em>Value</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Value</em>'.
   * @see edu.toronto.cs.istar.Property#getValue()
   * @see #getProperty()
   * @generated
   */
  EAttribute getProperty_Value();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Relation <em>Relation</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Relation</em>'.
   * @see edu.toronto.cs.istar.Relation
   * @generated
   */
  EClass getRelation();

  /**
   * Returns the meta object for the container reference '{@link edu.toronto.cs.istar.Relation#getActorFrom <em>Actor From</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Actor From</em>'.
   * @see edu.toronto.cs.istar.Relation#getActorFrom()
   * @see #getRelation()
   * @generated
   */
  EReference getRelation_ActorFrom();

  /**
   * Returns the meta object for the container reference '{@link edu.toronto.cs.istar.Relation#getActorTo <em>Actor To</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the container reference '<em>Actor To</em>'.
   * @see edu.toronto.cs.istar.Relation#getActorTo()
   * @see #getRelation()
   * @generated
   */
  EReference getRelation_ActorTo();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Resource <em>Resource</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Resource</em>'.
   * @see edu.toronto.cs.istar.Resource
   * @generated
   */
  EClass getResource();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.ResourceDependency <em>Resource Dependency</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Resource Dependency</em>'.
   * @see edu.toronto.cs.istar.ResourceDependency
   * @generated
   */
  EClass getResourceDependency();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Role <em>Role</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Role</em>'.
   * @see edu.toronto.cs.istar.Role
   * @generated
   */
  EClass getRole();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.SoftGoalDependency <em>Soft Goal Dependency</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Soft Goal Dependency</em>'.
   * @see edu.toronto.cs.istar.SoftGoalDependency
   * @generated
   */
  EClass getSoftGoalDependency();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Task <em>Task</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Task</em>'.
   * @see edu.toronto.cs.istar.Task
   * @generated
   */
  EClass getTask();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.TaskDependency <em>Task Dependency</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Task Dependency</em>'.
   * @see edu.toronto.cs.istar.TaskDependency
   * @generated
   */
  EClass getTaskDependency();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.Topic <em>Topic</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Topic</em>'.
   * @see edu.toronto.cs.istar.Topic
   * @generated
   */
  EClass getTopic();

  /**
   * Returns the meta object for the attribute '{@link edu.toronto.cs.istar.Topic#getTopic <em>Topic</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Topic</em>'.
   * @see edu.toronto.cs.istar.Topic#getTopic()
   * @see #getTopic()
   * @generated
   */
  EAttribute getTopic_Topic();

  /**
   * Returns the meta object for the attribute '{@link edu.toronto.cs.istar.Topic#getType <em>Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Type</em>'.
   * @see edu.toronto.cs.istar.Topic#getType()
   * @see #getTopic()
   * @generated
   */
  EAttribute getTopic_Type();

  /**
   * Returns the meta object for class '{@link edu.toronto.cs.istar.SoftGoal <em>Soft Goal</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Soft Goal</em>'.
   * @see edu.toronto.cs.istar.SoftGoal
   * @generated
   */
  EClass getSoftGoal();

  /**
   * Returns the meta object for the attribute '{@link edu.toronto.cs.istar.SoftGoal#getLabel <em>Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Label</em>'.
   * @see edu.toronto.cs.istar.SoftGoal#getLabel()
   * @see #getSoftGoal()
   * @generated
   */
  EAttribute getSoftGoal_Label();

  /**
   * Returns the meta object for enum '{@link edu.toronto.cs.istar.ConflictSoftLabel <em>Conflict Soft Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Conflict Soft Label</em>'.
   * @see edu.toronto.cs.istar.ConflictSoftLabel
   * @generated
   */
  EEnum getConflictSoftLabel();

  /**
   * Returns the meta object for enum '{@link edu.toronto.cs.istar.DeniedHardLabel <em>Denied Hard Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Denied Hard Label</em>'.
   * @see edu.toronto.cs.istar.DeniedHardLabel
   * @generated
   */
  EEnum getDeniedHardLabel();

  /**
   * Returns the meta object for enum '{@link edu.toronto.cs.istar.DeniedSoftLabel <em>Denied Soft Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Denied Soft Label</em>'.
   * @see edu.toronto.cs.istar.DeniedSoftLabel
   * @generated
   */
  EEnum getDeniedSoftLabel();

  /**
   * Returns the meta object for enum '{@link edu.toronto.cs.istar.HardLabel <em>Hard Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Hard Label</em>'.
   * @see edu.toronto.cs.istar.HardLabel
   * @generated
   */
  EEnum getHardLabel();

  /**
   * Returns the meta object for enum '{@link edu.toronto.cs.istar.Label <em>Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Label</em>'.
   * @see edu.toronto.cs.istar.Label
   * @generated
   */
  EEnum getLabel();

  /**
   * Returns the meta object for enum '{@link edu.toronto.cs.istar.PartiallyDeniedSoftLabel <em>Partially Denied Soft Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Partially Denied Soft Label</em>'.
   * @see edu.toronto.cs.istar.PartiallyDeniedSoftLabel
   * @generated
   */
  EEnum getPartiallyDeniedSoftLabel();

  /**
   * Returns the meta object for enum '{@link edu.toronto.cs.istar.PartiallySatisficedSoftLabel <em>Partially Satisficed Soft Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Partially Satisficed Soft Label</em>'.
   * @see edu.toronto.cs.istar.PartiallySatisficedSoftLabel
   * @generated
   */
  EEnum getPartiallySatisficedSoftLabel();

  /**
   * Returns the meta object for enum '{@link edu.toronto.cs.istar.SatisficedSoftLabel <em>Satisficed Soft Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Satisficed Soft Label</em>'.
   * @see edu.toronto.cs.istar.SatisficedSoftLabel
   * @generated
   */
  EEnum getSatisficedSoftLabel();

  /**
   * Returns the meta object for enum '{@link edu.toronto.cs.istar.SatisfiedHardLabel <em>Satisfied Hard Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Satisfied Hard Label</em>'.
   * @see edu.toronto.cs.istar.SatisfiedHardLabel
   * @generated
   */
  EEnum getSatisfiedHardLabel();

  /**
   * Returns the meta object for enum '{@link edu.toronto.cs.istar.SoftLabel <em>Soft Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Soft Label</em>'.
   * @see edu.toronto.cs.istar.SoftLabel
   * @generated
   */
  EEnum getSoftLabel();

  /**
   * Returns the meta object for enum '{@link edu.toronto.cs.istar.UnknownHardLabel <em>Unknown Hard Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Unknown Hard Label</em>'.
   * @see edu.toronto.cs.istar.UnknownHardLabel
   * @generated
   */
  EEnum getUnknownHardLabel();

  /**
   * Returns the meta object for enum '{@link edu.toronto.cs.istar.UnknownSoftLabel <em>Unknown Soft Label</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Unknown Soft Label</em>'.
   * @see edu.toronto.cs.istar.UnknownSoftLabel
   * @generated
   */
  EEnum getUnknownSoftLabel();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  IstarFactory getIstarFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.ActorImpl <em>Actor</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.ActorImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getActor()
     * @generated
     */
    EClass ACTOR = eINSTANCE.getActor();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute ACTOR__NAME = eINSTANCE.getActor_Name();

    /**
     * The meta object literal for the '<em><b>Intentions</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ACTOR__INTENTIONS = eINSTANCE.getActor_Intentions();

    /**
     * The meta object literal for the '<em><b>Relation From</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ACTOR__RELATION_FROM = eINSTANCE.getActor_RelationFrom();

    /**
     * The meta object literal for the '<em><b>Relation To</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ACTOR__RELATION_TO = eINSTANCE.getActor_RelationTo();

    /**
     * The meta object literal for the '<em><b>All Intentions</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference ACTOR__ALL_INTENTIONS = eINSTANCE.getActor_AllIntentions();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.AgentImpl <em>Agent</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.AgentImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getAgent()
     * @generated
     */
    EClass AGENT = eINSTANCE.getAgent();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.AndDecompositionImpl <em>And Decomposition</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.AndDecompositionImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getAndDecomposition()
     * @generated
     */
    EClass AND_DECOMPOSITION = eINSTANCE.getAndDecomposition();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.BreakContributionImpl <em>Break Contribution</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.BreakContributionImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getBreakContribution()
     * @generated
     */
    EClass BREAK_CONTRIBUTION = eINSTANCE.getBreakContribution();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.ContributionImpl <em>Contribution</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.ContributionImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getContribution()
     * @generated
     */
    EClass CONTRIBUTION = eINSTANCE.getContribution();

    /**
     * The meta object literal for the '<em><b>Target</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CONTRIBUTION__TARGET = eINSTANCE.getContribution_Target();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.DecompositionImpl <em>Decomposition</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.DecompositionImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getDecomposition()
     * @generated
     */
    EClass DECOMPOSITION = eINSTANCE.getDecomposition();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.DependencyImpl <em>Dependency</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.DependencyImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getDependency()
     * @generated
     */
    EClass DEPENDENCY = eINSTANCE.getDependency();

    /**
     * The meta object literal for the '<em><b>Intention From</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DEPENDENCY__INTENTION_FROM = eINSTANCE.getDependency_IntentionFrom();

    /**
     * The meta object literal for the '<em><b>Intention To</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference DEPENDENCY__INTENTION_TO = eINSTANCE.getDependency_IntentionTo();

    /**
     * The meta object literal for the '<em><b>Trust</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute DEPENDENCY__TRUST = eINSTANCE.getDependency_Trust();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.GoalImpl <em>Goal</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.GoalImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getGoal()
     * @generated
     */
    EClass GOAL = eINSTANCE.getGoal();

    /**
     * The meta object literal for the '<em><b>Label</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute GOAL__LABEL = eINSTANCE.getGoal_Label();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.GoalDependencyImpl <em>Goal Dependency</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.GoalDependencyImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getGoalDependency()
     * @generated
     */
    EClass GOAL_DEPENDENCY = eINSTANCE.getGoalDependency();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.HelpContributionImpl <em>Help Contribution</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.HelpContributionImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getHelpContribution()
     * @generated
     */
    EClass HELP_CONTRIBUTION = eINSTANCE.getHelpContribution();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.HurtContributionImpl <em>Hurt Contribution</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.HurtContributionImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getHurtContribution()
     * @generated
     */
    EClass HURT_CONTRIBUTION = eINSTANCE.getHurtContribution();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.IntentionImpl <em>Intention</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.IntentionImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getIntention()
     * @generated
     */
    EClass INTENTION = eINSTANCE.getIntention();

    /**
     * The meta object literal for the '<em><b>Root</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTENTION__ROOT = eINSTANCE.getIntention_Root();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INTENTION__NAME = eINSTANCE.getIntention_Name();

    /**
     * The meta object literal for the '<em><b>Property</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTENTION__PROPERTY = eINSTANCE.getIntention_Property();

    /**
     * The meta object literal for the '<em><b>Actor</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTENTION__ACTOR = eINSTANCE.getIntention_Actor();

    /**
     * The meta object literal for the '<em><b>Decomposition Type</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTENTION__DECOMPOSITION_TYPE = eINSTANCE.getIntention_DecompositionType();

    /**
     * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTENTION__PARENT = eINSTANCE.getIntention_Parent();

    /**
     * The meta object literal for the '<em><b>Children</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTENTION__CHILDREN = eINSTANCE.getIntention_Children();

    /**
     * The meta object literal for the '<em><b>Contributions</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTENTION__CONTRIBUTIONS = eINSTANCE.getIntention_Contributions();

    /**
     * The meta object literal for the '<em><b>Dependency From</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTENTION__DEPENDENCY_FROM = eINSTANCE.getIntention_DependencyFrom();

    /**
     * The meta object literal for the '<em><b>Dependency To</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTENTION__DEPENDENCY_TO = eINSTANCE.getIntention_DependencyTo();

    /**
     * The meta object literal for the '<em><b>Topic</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTENTION__TOPIC = eINSTANCE.getIntention_Topic();

    /**
     * The meta object literal for the '<em><b>Input</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTENTION__INPUT = eINSTANCE.getIntention_Input();

    /**
     * The meta object literal for the '<em><b>Output</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INTENTION__OUTPUT = eINSTANCE.getIntention_Output();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.LabelingImpl <em>Labeling</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.LabelingImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getLabeling()
     * @generated
     */
    EClass LABELING = eINSTANCE.getLabeling();

    /**
     * The meta object literal for the '<em><b>Label</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute LABELING__LABEL = eINSTANCE.getLabeling_Label();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.MakeContributionImpl <em>Make Contribution</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.MakeContributionImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getMakeContribution()
     * @generated
     */
    EClass MAKE_CONTRIBUTION = eINSTANCE.getMakeContribution();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.ModelImpl <em>Model</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.ModelImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getModel()
     * @generated
     */
    EClass MODEL = eINSTANCE.getModel();

    /**
     * The meta object literal for the '<em><b>Actors</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference MODEL__ACTORS = eINSTANCE.getModel_Actors();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.NoDecompositionImpl <em>No Decomposition</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.NoDecompositionImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getNoDecomposition()
     * @generated
     */
    EClass NO_DECOMPOSITION = eINSTANCE.getNoDecomposition();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.OrAndDecompositionImpl <em>Or And Decomposition</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.OrAndDecompositionImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getOrAndDecomposition()
     * @generated
     */
    EClass OR_AND_DECOMPOSITION = eINSTANCE.getOrAndDecomposition();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.PartOfRelationImpl <em>Part Of Relation</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.PartOfRelationImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getPartOfRelation()
     * @generated
     */
    EClass PART_OF_RELATION = eINSTANCE.getPartOfRelation();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.PlaysRelationImpl <em>Plays Relation</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.PlaysRelationImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getPlaysRelation()
     * @generated
     */
    EClass PLAYS_RELATION = eINSTANCE.getPlaysRelation();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.PositionImpl <em>Position</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.PositionImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getPosition()
     * @generated
     */
    EClass POSITION = eINSTANCE.getPosition();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.PropertyImpl <em>Property</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.PropertyImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getProperty()
     * @generated
     */
    EClass PROPERTY = eINSTANCE.getProperty();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PROPERTY__NAME = eINSTANCE.getProperty_Name();

    /**
     * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PROPERTY__VALUE = eINSTANCE.getProperty_Value();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.RelationImpl <em>Relation</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.RelationImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getRelation()
     * @generated
     */
    EClass RELATION = eINSTANCE.getRelation();

    /**
     * The meta object literal for the '<em><b>Actor From</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference RELATION__ACTOR_FROM = eINSTANCE.getRelation_ActorFrom();

    /**
     * The meta object literal for the '<em><b>Actor To</b></em>' container reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference RELATION__ACTOR_TO = eINSTANCE.getRelation_ActorTo();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.ResourceImpl <em>Resource</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.ResourceImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getResource()
     * @generated
     */
    EClass RESOURCE = eINSTANCE.getResource();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.ResourceDependencyImpl <em>Resource Dependency</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.ResourceDependencyImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getResourceDependency()
     * @generated
     */
    EClass RESOURCE_DEPENDENCY = eINSTANCE.getResourceDependency();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.RoleImpl <em>Role</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.RoleImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getRole()
     * @generated
     */
    EClass ROLE = eINSTANCE.getRole();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.SoftGoalDependencyImpl <em>Soft Goal Dependency</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.SoftGoalDependencyImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getSoftGoalDependency()
     * @generated
     */
    EClass SOFT_GOAL_DEPENDENCY = eINSTANCE.getSoftGoalDependency();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.TaskImpl <em>Task</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.TaskImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getTask()
     * @generated
     */
    EClass TASK = eINSTANCE.getTask();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.TaskDependencyImpl <em>Task Dependency</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.TaskDependencyImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getTaskDependency()
     * @generated
     */
    EClass TASK_DEPENDENCY = eINSTANCE.getTaskDependency();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.TopicImpl <em>Topic</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.TopicImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getTopic()
     * @generated
     */
    EClass TOPIC = eINSTANCE.getTopic();

    /**
     * The meta object literal for the '<em><b>Topic</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute TOPIC__TOPIC = eINSTANCE.getTopic_Topic();

    /**
     * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute TOPIC__TYPE = eINSTANCE.getTopic_Type();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.impl.SoftGoalImpl <em>Soft Goal</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.impl.SoftGoalImpl
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getSoftGoal()
     * @generated
     */
    EClass SOFT_GOAL = eINSTANCE.getSoftGoal();

    /**
     * The meta object literal for the '<em><b>Label</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute SOFT_GOAL__LABEL = eINSTANCE.getSoftGoal_Label();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.ConflictSoftLabel <em>Conflict Soft Label</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.ConflictSoftLabel
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getConflictSoftLabel()
     * @generated
     */
    EEnum CONFLICT_SOFT_LABEL = eINSTANCE.getConflictSoftLabel();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.DeniedHardLabel <em>Denied Hard Label</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.DeniedHardLabel
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getDeniedHardLabel()
     * @generated
     */
    EEnum DENIED_HARD_LABEL = eINSTANCE.getDeniedHardLabel();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.DeniedSoftLabel <em>Denied Soft Label</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.DeniedSoftLabel
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getDeniedSoftLabel()
     * @generated
     */
    EEnum DENIED_SOFT_LABEL = eINSTANCE.getDeniedSoftLabel();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.HardLabel <em>Hard Label</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.HardLabel
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getHardLabel()
     * @generated
     */
    EEnum HARD_LABEL = eINSTANCE.getHardLabel();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.Label <em>Label</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.Label
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getLabel()
     * @generated
     */
    EEnum LABEL = eINSTANCE.getLabel();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.PartiallyDeniedSoftLabel <em>Partially Denied Soft Label</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.PartiallyDeniedSoftLabel
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getPartiallyDeniedSoftLabel()
     * @generated
     */
    EEnum PARTIALLY_DENIED_SOFT_LABEL = eINSTANCE.getPartiallyDeniedSoftLabel();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.PartiallySatisficedSoftLabel <em>Partially Satisficed Soft Label</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.PartiallySatisficedSoftLabel
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getPartiallySatisficedSoftLabel()
     * @generated
     */
    EEnum PARTIALLY_SATISFICED_SOFT_LABEL = eINSTANCE.getPartiallySatisficedSoftLabel();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.SatisficedSoftLabel <em>Satisficed Soft Label</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.SatisficedSoftLabel
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getSatisficedSoftLabel()
     * @generated
     */
    EEnum SATISFICED_SOFT_LABEL = eINSTANCE.getSatisficedSoftLabel();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.SatisfiedHardLabel <em>Satisfied Hard Label</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.SatisfiedHardLabel
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getSatisfiedHardLabel()
     * @generated
     */
    EEnum SATISFIED_HARD_LABEL = eINSTANCE.getSatisfiedHardLabel();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.SoftLabel <em>Soft Label</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.SoftLabel
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getSoftLabel()
     * @generated
     */
    EEnum SOFT_LABEL = eINSTANCE.getSoftLabel();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.UnknownHardLabel <em>Unknown Hard Label</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.UnknownHardLabel
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getUnknownHardLabel()
     * @generated
     */
    EEnum UNKNOWN_HARD_LABEL = eINSTANCE.getUnknownHardLabel();

    /**
     * The meta object literal for the '{@link edu.toronto.cs.istar.UnknownSoftLabel <em>Unknown Soft Label</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see edu.toronto.cs.istar.UnknownSoftLabel
     * @see edu.toronto.cs.istar.impl.IstarPackageImpl#getUnknownSoftLabel()
     * @generated
     */
    EEnum UNKNOWN_SOFT_LABEL = eINSTANCE.getUnknownSoftLabel();

  }

} //IstarPackage
