/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package edu.toronto.cs.istar.impl;

import edu.toronto.cs.istar.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class IstarFactoryImpl extends EFactoryImpl implements IstarFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static IstarFactory init()
  {
    try
    {
      IstarFactory theIstarFactory = (IstarFactory)EPackage.Registry.INSTANCE.getEFactory("http:///edu/toronto/cs/istar.ecore"); 
      if (theIstarFactory != null)
      {
        return theIstarFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new IstarFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IstarFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case IstarPackage.ACTOR: return createActor();
      case IstarPackage.AGENT: return createAgent();
      case IstarPackage.AND_DECOMPOSITION: return createAndDecomposition();
      case IstarPackage.BREAK_CONTRIBUTION: return createBreakContribution();
      case IstarPackage.CONTRIBUTION: return createContribution();
      case IstarPackage.DECOMPOSITION: return createDecomposition();
      case IstarPackage.DEPENDENCY: return createDependency();
      case IstarPackage.GOAL: return createGoal();
      case IstarPackage.GOAL_DEPENDENCY: return createGoalDependency();
      case IstarPackage.HELP_CONTRIBUTION: return createHelpContribution();
      case IstarPackage.HURT_CONTRIBUTION: return createHurtContribution();
      case IstarPackage.INTENTION: return createIntention();
      case IstarPackage.LABELING: return createLabeling();
      case IstarPackage.MAKE_CONTRIBUTION: return createMakeContribution();
      case IstarPackage.MODEL: return createModel();
      case IstarPackage.NO_DECOMPOSITION: return createNoDecomposition();
      case IstarPackage.OR_AND_DECOMPOSITION: return createOrAndDecomposition();
      case IstarPackage.PART_OF_RELATION: return createPartOfRelation();
      case IstarPackage.PLAYS_RELATION: return createPlaysRelation();
      case IstarPackage.POSITION: return createPosition();
      case IstarPackage.PROPERTY: return createProperty();
      case IstarPackage.RELATION: return createRelation();
      case IstarPackage.RESOURCE: return createResource();
      case IstarPackage.RESOURCE_DEPENDENCY: return createResourceDependency();
      case IstarPackage.ROLE: return createRole();
      case IstarPackage.SOFT_GOAL_DEPENDENCY: return createSoftGoalDependency();
      case IstarPackage.TASK: return createTask();
      case IstarPackage.TASK_DEPENDENCY: return createTaskDependency();
      case IstarPackage.TOPIC: return createTopic();
      case IstarPackage.SOFT_GOAL: return createSoftGoal();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case IstarPackage.CONFLICT_SOFT_LABEL:
        return createConflictSoftLabelFromString(eDataType, initialValue);
      case IstarPackage.DENIED_HARD_LABEL:
        return createDeniedHardLabelFromString(eDataType, initialValue);
      case IstarPackage.DENIED_SOFT_LABEL:
        return createDeniedSoftLabelFromString(eDataType, initialValue);
      case IstarPackage.HARD_LABEL:
        return createHardLabelFromString(eDataType, initialValue);
      case IstarPackage.LABEL:
        return createLabelFromString(eDataType, initialValue);
      case IstarPackage.PARTIALLY_DENIED_SOFT_LABEL:
        return createPartiallyDeniedSoftLabelFromString(eDataType, initialValue);
      case IstarPackage.PARTIALLY_SATISFICED_SOFT_LABEL:
        return createPartiallySatisficedSoftLabelFromString(eDataType, initialValue);
      case IstarPackage.SATISFICED_SOFT_LABEL:
        return createSatisficedSoftLabelFromString(eDataType, initialValue);
      case IstarPackage.SATISFIED_HARD_LABEL:
        return createSatisfiedHardLabelFromString(eDataType, initialValue);
      case IstarPackage.SOFT_LABEL:
        return createSoftLabelFromString(eDataType, initialValue);
      case IstarPackage.UNKNOWN_HARD_LABEL:
        return createUnknownHardLabelFromString(eDataType, initialValue);
      case IstarPackage.UNKNOWN_SOFT_LABEL:
        return createUnknownSoftLabelFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case IstarPackage.CONFLICT_SOFT_LABEL:
        return convertConflictSoftLabelToString(eDataType, instanceValue);
      case IstarPackage.DENIED_HARD_LABEL:
        return convertDeniedHardLabelToString(eDataType, instanceValue);
      case IstarPackage.DENIED_SOFT_LABEL:
        return convertDeniedSoftLabelToString(eDataType, instanceValue);
      case IstarPackage.HARD_LABEL:
        return convertHardLabelToString(eDataType, instanceValue);
      case IstarPackage.LABEL:
        return convertLabelToString(eDataType, instanceValue);
      case IstarPackage.PARTIALLY_DENIED_SOFT_LABEL:
        return convertPartiallyDeniedSoftLabelToString(eDataType, instanceValue);
      case IstarPackage.PARTIALLY_SATISFICED_SOFT_LABEL:
        return convertPartiallySatisficedSoftLabelToString(eDataType, instanceValue);
      case IstarPackage.SATISFICED_SOFT_LABEL:
        return convertSatisficedSoftLabelToString(eDataType, instanceValue);
      case IstarPackage.SATISFIED_HARD_LABEL:
        return convertSatisfiedHardLabelToString(eDataType, instanceValue);
      case IstarPackage.SOFT_LABEL:
        return convertSoftLabelToString(eDataType, instanceValue);
      case IstarPackage.UNKNOWN_HARD_LABEL:
        return convertUnknownHardLabelToString(eDataType, instanceValue);
      case IstarPackage.UNKNOWN_SOFT_LABEL:
        return convertUnknownSoftLabelToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Actor createActor()
  {
    ActorImpl actor = new ActorImpl();
    return actor;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Agent createAgent()
  {
    AgentImpl agent = new AgentImpl();
    return agent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AndDecomposition createAndDecomposition()
  {
    AndDecompositionImpl andDecomposition = new AndDecompositionImpl();
    return andDecomposition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public BreakContribution createBreakContribution()
  {
    BreakContributionImpl breakContribution = new BreakContributionImpl();
    return breakContribution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Contribution createContribution()
  {
    ContributionImpl contribution = new ContributionImpl();
    return contribution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Decomposition createDecomposition()
  {
    DecompositionImpl decomposition = new DecompositionImpl();
    return decomposition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Dependency createDependency()
  {
    DependencyImpl dependency = new DependencyImpl();
    return dependency;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Goal createGoal()
  {
    GoalImpl goal = new GoalImpl();
    return goal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public GoalDependency createGoalDependency()
  {
    GoalDependencyImpl goalDependency = new GoalDependencyImpl();
    return goalDependency;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HelpContribution createHelpContribution()
  {
    HelpContributionImpl helpContribution = new HelpContributionImpl();
    return helpContribution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HurtContribution createHurtContribution()
  {
    HurtContributionImpl hurtContribution = new HurtContributionImpl();
    return hurtContribution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Intention createIntention()
  {
    IntentionImpl intention = new IntentionImpl();
    return intention;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Labeling createLabeling()
  {
    LabelingImpl labeling = new LabelingImpl();
    return labeling;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MakeContribution createMakeContribution()
  {
    MakeContributionImpl makeContribution = new MakeContributionImpl();
    return makeContribution;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Model createModel()
  {
    ModelImpl model = new ModelImpl();
    return model;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NoDecomposition createNoDecomposition()
  {
    NoDecompositionImpl noDecomposition = new NoDecompositionImpl();
    return noDecomposition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OrAndDecomposition createOrAndDecomposition()
  {
    OrAndDecompositionImpl orAndDecomposition = new OrAndDecompositionImpl();
    return orAndDecomposition;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PartOfRelation createPartOfRelation()
  {
    PartOfRelationImpl partOfRelation = new PartOfRelationImpl();
    return partOfRelation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PlaysRelation createPlaysRelation()
  {
    PlaysRelationImpl playsRelation = new PlaysRelationImpl();
    return playsRelation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Position createPosition()
  {
    PositionImpl position = new PositionImpl();
    return position;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Property createProperty()
  {
    PropertyImpl property = new PropertyImpl();
    return property;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Relation createRelation()
  {
    RelationImpl relation = new RelationImpl();
    return relation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Resource createResource()
  {
    ResourceImpl resource = new ResourceImpl();
    return resource;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ResourceDependency createResourceDependency()
  {
    ResourceDependencyImpl resourceDependency = new ResourceDependencyImpl();
    return resourceDependency;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Role createRole()
  {
    RoleImpl role = new RoleImpl();
    return role;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SoftGoalDependency createSoftGoalDependency()
  {
    SoftGoalDependencyImpl softGoalDependency = new SoftGoalDependencyImpl();
    return softGoalDependency;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Task createTask()
  {
    TaskImpl task = new TaskImpl();
    return task;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TaskDependency createTaskDependency()
  {
    TaskDependencyImpl taskDependency = new TaskDependencyImpl();
    return taskDependency;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Topic createTopic()
  {
    TopicImpl topic = new TopicImpl();
    return topic;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SoftGoal createSoftGoal()
  {
    SoftGoalImpl softGoal = new SoftGoalImpl();
    return softGoal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConflictSoftLabel createConflictSoftLabelFromString(EDataType eDataType, String initialValue)
  {
    ConflictSoftLabel result = ConflictSoftLabel.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertConflictSoftLabelToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DeniedHardLabel createDeniedHardLabelFromString(EDataType eDataType, String initialValue)
  {
    DeniedHardLabel result = DeniedHardLabel.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertDeniedHardLabelToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DeniedSoftLabel createDeniedSoftLabelFromString(EDataType eDataType, String initialValue)
  {
    DeniedSoftLabel result = DeniedSoftLabel.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertDeniedSoftLabelToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public HardLabel createHardLabelFromString(EDataType eDataType, String initialValue)
  {
    HardLabel result = HardLabel.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertHardLabelToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Label createLabelFromString(EDataType eDataType, String initialValue)
  {
    Label result = Label.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertLabelToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PartiallyDeniedSoftLabel createPartiallyDeniedSoftLabelFromString(EDataType eDataType, String initialValue)
  {
    PartiallyDeniedSoftLabel result = PartiallyDeniedSoftLabel.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertPartiallyDeniedSoftLabelToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PartiallySatisficedSoftLabel createPartiallySatisficedSoftLabelFromString(EDataType eDataType, String initialValue)
  {
    PartiallySatisficedSoftLabel result = PartiallySatisficedSoftLabel.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertPartiallySatisficedSoftLabelToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SatisficedSoftLabel createSatisficedSoftLabelFromString(EDataType eDataType, String initialValue)
  {
    SatisficedSoftLabel result = SatisficedSoftLabel.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertSatisficedSoftLabelToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SatisfiedHardLabel createSatisfiedHardLabelFromString(EDataType eDataType, String initialValue)
  {
    SatisfiedHardLabel result = SatisfiedHardLabel.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertSatisfiedHardLabelToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SoftLabel createSoftLabelFromString(EDataType eDataType, String initialValue)
  {
    SoftLabel result = SoftLabel.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertSoftLabelToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public UnknownHardLabel createUnknownHardLabelFromString(EDataType eDataType, String initialValue)
  {
    UnknownHardLabel result = UnknownHardLabel.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertUnknownHardLabelToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public UnknownSoftLabel createUnknownSoftLabelFromString(EDataType eDataType, String initialValue)
  {
    UnknownSoftLabel result = UnknownSoftLabel.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertUnknownSoftLabelToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IstarPackage getIstarPackage()
  {
    return (IstarPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  public static IstarPackage getPackage()
  {
    return IstarPackage.eINSTANCE;
  }

} //IstarFactoryImpl
