/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package edu.toronto.cs.istar.util;

import edu.toronto.cs.istar.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see edu.toronto.cs.istar.IstarPackage
 * @generated
 */
public class IstarAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static IstarPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IstarAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = IstarPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch the delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected IstarSwitch modelSwitch =
    new IstarSwitch()
    {
      public Object caseActor(Actor object)
      {
        return createActorAdapter();
      }
      public Object caseAgent(Agent object)
      {
        return createAgentAdapter();
      }
      public Object caseAndDecomposition(AndDecomposition object)
      {
        return createAndDecompositionAdapter();
      }
      public Object caseBreakContribution(BreakContribution object)
      {
        return createBreakContributionAdapter();
      }
      public Object caseContribution(Contribution object)
      {
        return createContributionAdapter();
      }
      public Object caseDecomposition(Decomposition object)
      {
        return createDecompositionAdapter();
      }
      public Object caseDependency(Dependency object)
      {
        return createDependencyAdapter();
      }
      public Object caseGoal(Goal object)
      {
        return createGoalAdapter();
      }
      public Object caseGoalDependency(GoalDependency object)
      {
        return createGoalDependencyAdapter();
      }
      public Object caseHelpContribution(HelpContribution object)
      {
        return createHelpContributionAdapter();
      }
      public Object caseHurtContribution(HurtContribution object)
      {
        return createHurtContributionAdapter();
      }
      public Object caseIntention(Intention object)
      {
        return createIntentionAdapter();
      }
      public Object caseLabeling(Labeling object)
      {
        return createLabelingAdapter();
      }
      public Object caseMakeContribution(MakeContribution object)
      {
        return createMakeContributionAdapter();
      }
      public Object caseModel(Model object)
      {
        return createModelAdapter();
      }
      public Object caseNoDecomposition(NoDecomposition object)
      {
        return createNoDecompositionAdapter();
      }
      public Object caseOrAndDecomposition(OrAndDecomposition object)
      {
        return createOrAndDecompositionAdapter();
      }
      public Object casePartOfRelation(PartOfRelation object)
      {
        return createPartOfRelationAdapter();
      }
      public Object casePlaysRelation(PlaysRelation object)
      {
        return createPlaysRelationAdapter();
      }
      public Object casePosition(Position object)
      {
        return createPositionAdapter();
      }
      public Object caseProperty(Property object)
      {
        return createPropertyAdapter();
      }
      public Object caseRelation(Relation object)
      {
        return createRelationAdapter();
      }
      public Object caseResource(Resource object)
      {
        return createResourceAdapter();
      }
      public Object caseResourceDependency(ResourceDependency object)
      {
        return createResourceDependencyAdapter();
      }
      public Object caseRole(Role object)
      {
        return createRoleAdapter();
      }
      public Object caseSoftGoalDependency(SoftGoalDependency object)
      {
        return createSoftGoalDependencyAdapter();
      }
      public Object caseTask(Task object)
      {
        return createTaskAdapter();
      }
      public Object caseTaskDependency(TaskDependency object)
      {
        return createTaskDependencyAdapter();
      }
      public Object caseTopic(Topic object)
      {
        return createTopicAdapter();
      }
      public Object caseSoftGoal(SoftGoal object)
      {
        return createSoftGoalAdapter();
      }
      public Object defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  public Adapter createAdapter(Notifier target)
  {
    return (Adapter)modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Actor <em>Actor</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Actor
   * @generated
   */
  public Adapter createActorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Agent <em>Agent</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Agent
   * @generated
   */
  public Adapter createAgentAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.AndDecomposition <em>And Decomposition</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.AndDecomposition
   * @generated
   */
  public Adapter createAndDecompositionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.BreakContribution <em>Break Contribution</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.BreakContribution
   * @generated
   */
  public Adapter createBreakContributionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Contribution <em>Contribution</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Contribution
   * @generated
   */
  public Adapter createContributionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Decomposition <em>Decomposition</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Decomposition
   * @generated
   */
  public Adapter createDecompositionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Dependency <em>Dependency</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Dependency
   * @generated
   */
  public Adapter createDependencyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Goal <em>Goal</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Goal
   * @generated
   */
  public Adapter createGoalAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.GoalDependency <em>Goal Dependency</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.GoalDependency
   * @generated
   */
  public Adapter createGoalDependencyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.HelpContribution <em>Help Contribution</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.HelpContribution
   * @generated
   */
  public Adapter createHelpContributionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.HurtContribution <em>Hurt Contribution</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.HurtContribution
   * @generated
   */
  public Adapter createHurtContributionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Intention <em>Intention</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Intention
   * @generated
   */
  public Adapter createIntentionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Labeling <em>Labeling</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Labeling
   * @generated
   */
  public Adapter createLabelingAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.MakeContribution <em>Make Contribution</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.MakeContribution
   * @generated
   */
  public Adapter createMakeContributionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Model <em>Model</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Model
   * @generated
   */
  public Adapter createModelAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.NoDecomposition <em>No Decomposition</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.NoDecomposition
   * @generated
   */
  public Adapter createNoDecompositionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.OrAndDecomposition <em>Or And Decomposition</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.OrAndDecomposition
   * @generated
   */
  public Adapter createOrAndDecompositionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.PartOfRelation <em>Part Of Relation</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.PartOfRelation
   * @generated
   */
  public Adapter createPartOfRelationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.PlaysRelation <em>Plays Relation</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.PlaysRelation
   * @generated
   */
  public Adapter createPlaysRelationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Position <em>Position</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Position
   * @generated
   */
  public Adapter createPositionAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Property <em>Property</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Property
   * @generated
   */
  public Adapter createPropertyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Relation <em>Relation</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Relation
   * @generated
   */
  public Adapter createRelationAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Resource <em>Resource</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Resource
   * @generated
   */
  public Adapter createResourceAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.ResourceDependency <em>Resource Dependency</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.ResourceDependency
   * @generated
   */
  public Adapter createResourceDependencyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Role <em>Role</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Role
   * @generated
   */
  public Adapter createRoleAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.SoftGoalDependency <em>Soft Goal Dependency</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.SoftGoalDependency
   * @generated
   */
  public Adapter createSoftGoalDependencyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Task <em>Task</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Task
   * @generated
   */
  public Adapter createTaskAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.TaskDependency <em>Task Dependency</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.TaskDependency
   * @generated
   */
  public Adapter createTaskDependencyAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.Topic <em>Topic</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.Topic
   * @generated
   */
  public Adapter createTopicAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link edu.toronto.cs.istar.SoftGoal <em>Soft Goal</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see edu.toronto.cs.istar.SoftGoal
   * @generated
   */
  public Adapter createSoftGoalAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //IstarAdapterFactory
