/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package edu.toronto.cs.istar.util;

import edu.toronto.cs.istar.*;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see edu.toronto.cs.istar.IstarPackage
 * @generated
 */
public class IstarSwitch
{
  /**
   * The cached model package
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static IstarPackage modelPackage;

  /**
   * Creates an instance of the switch.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IstarSwitch()
  {
    if (modelPackage == null)
    {
      modelPackage = IstarPackage.eINSTANCE;
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  public Object doSwitch(EObject theEObject)
  {
    return doSwitch(theEObject.eClass(), theEObject);
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  protected Object doSwitch(EClass theEClass, EObject theEObject)
  {
    if (theEClass.eContainer() == modelPackage)
    {
      return doSwitch(theEClass.getClassifierID(), theEObject);
    }
    else
    {
      List eSuperTypes = theEClass.getESuperTypes();
      return
        eSuperTypes.isEmpty() ?
          defaultCase(theEObject) :
          doSwitch((EClass)eSuperTypes.get(0), theEObject);
    }
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  protected Object doSwitch(int classifierID, EObject theEObject)
  {
    switch (classifierID)
    {
      case IstarPackage.ACTOR:
      {
        Actor actor = (Actor)theEObject;
        Object result = caseActor(actor);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.AGENT:
      {
        Agent agent = (Agent)theEObject;
        Object result = caseAgent(agent);
        if (result == null) result = caseActor(agent);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.AND_DECOMPOSITION:
      {
        AndDecomposition andDecomposition = (AndDecomposition)theEObject;
        Object result = caseAndDecomposition(andDecomposition);
        if (result == null) result = caseDecomposition(andDecomposition);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.BREAK_CONTRIBUTION:
      {
        BreakContribution breakContribution = (BreakContribution)theEObject;
        Object result = caseBreakContribution(breakContribution);
        if (result == null) result = caseContribution(breakContribution);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.CONTRIBUTION:
      {
        Contribution contribution = (Contribution)theEObject;
        Object result = caseContribution(contribution);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.DECOMPOSITION:
      {
        Decomposition decomposition = (Decomposition)theEObject;
        Object result = caseDecomposition(decomposition);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.DEPENDENCY:
      {
        Dependency dependency = (Dependency)theEObject;
        Object result = caseDependency(dependency);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.GOAL:
      {
        Goal goal = (Goal)theEObject;
        Object result = caseGoal(goal);
        if (result == null) result = caseIntention(goal);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.GOAL_DEPENDENCY:
      {
        GoalDependency goalDependency = (GoalDependency)theEObject;
        Object result = caseGoalDependency(goalDependency);
        if (result == null) result = caseDependency(goalDependency);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.HELP_CONTRIBUTION:
      {
        HelpContribution helpContribution = (HelpContribution)theEObject;
        Object result = caseHelpContribution(helpContribution);
        if (result == null) result = caseContribution(helpContribution);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.HURT_CONTRIBUTION:
      {
        HurtContribution hurtContribution = (HurtContribution)theEObject;
        Object result = caseHurtContribution(hurtContribution);
        if (result == null) result = caseContribution(hurtContribution);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.INTENTION:
      {
        Intention intention = (Intention)theEObject;
        Object result = caseIntention(intention);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.LABELING:
      {
        Labeling labeling = (Labeling)theEObject;
        Object result = caseLabeling(labeling);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.MAKE_CONTRIBUTION:
      {
        MakeContribution makeContribution = (MakeContribution)theEObject;
        Object result = caseMakeContribution(makeContribution);
        if (result == null) result = caseContribution(makeContribution);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.MODEL:
      {
        Model model = (Model)theEObject;
        Object result = caseModel(model);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.NO_DECOMPOSITION:
      {
        NoDecomposition noDecomposition = (NoDecomposition)theEObject;
        Object result = caseNoDecomposition(noDecomposition);
        if (result == null) result = caseDecomposition(noDecomposition);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.OR_AND_DECOMPOSITION:
      {
        OrAndDecomposition orAndDecomposition = (OrAndDecomposition)theEObject;
        Object result = caseOrAndDecomposition(orAndDecomposition);
        if (result == null) result = caseDecomposition(orAndDecomposition);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.PART_OF_RELATION:
      {
        PartOfRelation partOfRelation = (PartOfRelation)theEObject;
        Object result = casePartOfRelation(partOfRelation);
        if (result == null) result = caseRelation(partOfRelation);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.PLAYS_RELATION:
      {
        PlaysRelation playsRelation = (PlaysRelation)theEObject;
        Object result = casePlaysRelation(playsRelation);
        if (result == null) result = caseRelation(playsRelation);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.POSITION:
      {
        Position position = (Position)theEObject;
        Object result = casePosition(position);
        if (result == null) result = caseActor(position);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.PROPERTY:
      {
        Property property = (Property)theEObject;
        Object result = caseProperty(property);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.RELATION:
      {
        Relation relation = (Relation)theEObject;
        Object result = caseRelation(relation);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.RESOURCE:
      {
        Resource resource = (Resource)theEObject;
        Object result = caseResource(resource);
        if (result == null) result = caseIntention(resource);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.RESOURCE_DEPENDENCY:
      {
        ResourceDependency resourceDependency = (ResourceDependency)theEObject;
        Object result = caseResourceDependency(resourceDependency);
        if (result == null) result = caseDependency(resourceDependency);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.ROLE:
      {
        Role role = (Role)theEObject;
        Object result = caseRole(role);
        if (result == null) result = caseActor(role);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.SOFT_GOAL_DEPENDENCY:
      {
        SoftGoalDependency softGoalDependency = (SoftGoalDependency)theEObject;
        Object result = caseSoftGoalDependency(softGoalDependency);
        if (result == null) result = caseDependency(softGoalDependency);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.TASK:
      {
        Task task = (Task)theEObject;
        Object result = caseTask(task);
        if (result == null) result = caseIntention(task);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.TASK_DEPENDENCY:
      {
        TaskDependency taskDependency = (TaskDependency)theEObject;
        Object result = caseTaskDependency(taskDependency);
        if (result == null) result = caseDependency(taskDependency);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.TOPIC:
      {
        Topic topic = (Topic)theEObject;
        Object result = caseTopic(topic);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case IstarPackage.SOFT_GOAL:
      {
        SoftGoal softGoal = (SoftGoal)theEObject;
        Object result = caseSoftGoal(softGoal);
        if (result == null) result = caseIntention(softGoal);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      default: return defaultCase(theEObject);
    }
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Actor</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Actor</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseActor(Actor object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Agent</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Agent</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseAgent(Agent object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>And Decomposition</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>And Decomposition</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseAndDecomposition(AndDecomposition object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Break Contribution</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Break Contribution</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseBreakContribution(BreakContribution object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Contribution</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Contribution</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseContribution(Contribution object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Decomposition</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Decomposition</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseDecomposition(Decomposition object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Dependency</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Dependency</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseDependency(Dependency object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Goal</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Goal</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseGoal(Goal object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Goal Dependency</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Goal Dependency</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseGoalDependency(GoalDependency object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Help Contribution</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Help Contribution</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseHelpContribution(HelpContribution object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Hurt Contribution</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Hurt Contribution</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseHurtContribution(HurtContribution object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Intention</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Intention</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseIntention(Intention object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Labeling</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Labeling</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseLabeling(Labeling object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Make Contribution</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Make Contribution</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseMakeContribution(MakeContribution object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Model</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Model</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseModel(Model object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>No Decomposition</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>No Decomposition</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseNoDecomposition(NoDecomposition object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Or And Decomposition</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Or And Decomposition</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseOrAndDecomposition(OrAndDecomposition object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Part Of Relation</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Part Of Relation</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object casePartOfRelation(PartOfRelation object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Plays Relation</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Plays Relation</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object casePlaysRelation(PlaysRelation object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Position</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Position</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object casePosition(Position object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Property</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Property</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseProperty(Property object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Relation</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Relation</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseRelation(Relation object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Resource</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Resource</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseResource(Resource object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Resource Dependency</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Resource Dependency</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseResourceDependency(ResourceDependency object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Role</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Role</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseRole(Role object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Soft Goal Dependency</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Soft Goal Dependency</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseSoftGoalDependency(SoftGoalDependency object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Task</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Task</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseTask(Task object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Task Dependency</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Task Dependency</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseTaskDependency(TaskDependency object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Topic</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Topic</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseTopic(Topic object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>Soft Goal</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>Soft Goal</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public Object caseSoftGoal(SoftGoal object)
  {
    return null;
  }

  /**
   * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch, but this is the last case anyway.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject)
   * @generated
   */
  public Object defaultCase(EObject object)
  {
    return null;
  }

} //IstarSwitch
